// Copyright (C) 2005-2007 Lionel Duchateau, kurtnoise@free.fr
//
// This library is free software: you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this library. If not, see <http://www.gnu.org/licenses/>.
//
// To compile Yamb 2.xxx, you need Delphi 7 Pro (or higher) and :
//    - JVCL components : http://homepages.borland.com/jedi/jvcl/
//    - TMMS Unicode components : http://www.tmssoftware.com/
//    - DSPack components : http://www.progdigy.com/
//    - ABf components : http://www.abf-dev.com/abf-components.shtml
//    - DOSCommand component : include in the sources
//    - OpenDirDialog component : include in the sources
//

unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvExControls, JvComponent, JvWizard, ExtCtrls, JvExExtCtrls,
  JvSecretPanel,ImgList, ComCtrls, JvExComCtrls, JvListView,
  StdCtrls, TntStdCtrls, TntExtCtrls, TntWindows, TntDialogs,
  JvComponentBase, JvBaseDlg, JvBrowseFolder, Buttons, TntButtons,
  TntComCtrls, ToolWin, MediaInfoDll, TntSysUtils, ShellAPI, TntMenus,
  DosCommand, TntWideStrings, iniFiles, DateUtils, Menus, TntClasses,
  abfControls, StrUtils, DSPack, StShlCtl, jpeg, OpenDirDialog, XPMan,
  scFileDrop, TaskDialog, FileCtrl, TntTaskDialog, JvgWizardHeader,
  JvExStdCtrls, JvListBox, JvDriveCtrls, LsFileExplorer28, TntExtDlgs;


type
  TMainForm = class(TForm)
    Wizard: TJvWizard;
    Page1: TJvWizardWelcomePage;
    MainList: TListView;
    ImageList1: TImageList;
    ImageList2: TImageList;
    AboutPanel: TTntPanel;
    gbAbout: TTntGroupBox;
    TntImage1: TTntImage;
    TntImage3: TTntImage;
    TntImage2: TTntImage;
    TntLabel1: TTntLabel;
    TntLabel2: TTntLabel;
    lbLinks: TTntLabel;
    lbMP4Box: TTntLabel;
    TntImage4: TTntImage;
    lbAP: TTntLabel;
    TntImage5: TTntImage;
    lbMP4Tags: TTntLabel;
    TntImage6: TTntImage;
    lbYamb: TTntLabel;
    TntImage7: TTntImage;
    lbThanks: TTntLabel;
    lbMediaInfo: TTntLabel;
    TntImage8: TTntImage;
    lbJVCL: TTntLabel;
    TntImage9: TTntImage;
    lbKDE: TTntLabel;
    TntImage10: TTntImage;
    lbYou: TTntLabel;
    lbMail: TTntLabel;
    TntImage11: TTntImage;
    ImageList3: TImageList;
    ImageList4: TImageList;
    SettingsPage: TJvWizardInteriorPage;
    gbMP4Box: TTntGroupBox;
    lbMP4Boxlocation: TTntLabel;
    edMP4Box: TTntEdit;
    TntImage13: TTntImage;
    chOverWrite: TTntCheckBox;
    chKeepSys: TTntCheckBox;
    MuxPage: TJvWizardInteriorPage;
    gbInput: TTntGroupBox;
    gbMP4Output: TTntGroupBox;
    edMP4Output: TTntEdit;
    btMP4Output: TTntBitBtn;
    MP4ListView: TTntListView;
    btAdd: TTntBitBtn;
    btDelete: TTntBitBtn;
    btMoveUp: TTntBitBtn;
    btMoveDown: TTntBitBtn;
    btProperties: TTntBitBtn;
    ProcessPage: TJvWizardInteriorPage;
    SplitPage: TJvWizardInteriorPage;
    gbRunningProcess: TTntGroupBox;
    ETAListView: TTntListView;
    ProgressBar: TTntProgressBar;
    btAbort: TTntBitBtn;
    lbCurrentStatus: TTntLabel;
    lbPercent: TTntLabel;
    lbTime: TTntLabel;
    lbTimeRemaining: TTntLabel;
    gbSplitInput: TTntGroupBox;
    edSplitInput: TTntEdit;
    TntImage18: TTntImage;
    gbSplitOptions: TTntGroupBox;
    chVIdeoPreview: TTntCheckBox;
    ImageList5: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    TntBevel1: TTntBevel;
    rbSize: TTntRadioButton;
    rbDuration: TTntRadioButton;
    rbFrom: TTntRadioButton;
    edSplitFrom: TTntEdit;
    lbTo: TTntLabel;
    edSplitTo: TTntEdit;
    rbSplitChapN: TTntRadioButton;
    rbSplitChapAll: TTntRadioButton;
    cbChap: TTntComboBox;
    edSplitSize: TTntEdit;
    edSplitDuration: TTntEdit;
    lbMB: TTntLabel;
    UpDown1: TUpDown;
    ConcatPage: TJvWizardInteriorPage;
    gbConcInput: TTntGroupBox;
    ConcListView: TTntListView;
    btConcAdd: TTntBitBtn;
    btConcRemove: TTntBitBtn;
    btConcMoveUp: TTntBitBtn;
    btConcMoveDown: TTntBitBtn;
    btConcProp: TTntBitBtn;
    gbConcOutput: TTntGroupBox;
    edConcOutput: TTntEdit;
    btConcBrowse: TTntBitBtn;
    ExtractPage: TJvWizardInteriorPage;
    gbExtractInput: TTntGroupBox;
    TntImage21: TTntImage;
    edExtractInput: TTntEdit;
    gbContent: TTntGroupBox;
    ExtractListView: TTntListView;
    ConverterPage: TJvWizardInteriorPage;
    gbConverterInput: TTntGroupBox;
    TntImage23: TTntImage;
    edConvInput: TTntEdit;
    gbSub: TTntGroupBox;
    rbSRT: TTntRadioButton;
    rbTTXT: TTntRadioButton;
    gbAVIOptions: TTntGroupBox;
    AVIConverterText: TTntStaticText;
    lbFrameRate: TTntLabel;
    edFrameRate: TTntEdit;
    TagPage: TJvWizardInteriorPage;
    ImageList6: TImageList;
    VideoTrackBar: TTrackBar;
    Timer1: TTimer;
    PopupMenu1: TTntPopupMenu;
    Index1: TTntMenuItem;
    Description1: TTntMenuItem;
    Name1: TTntMenuItem;
    Language1: TTntMenuItem;
    Memo1: TMemo;
    gbExtractOptions: TTntGroupBox;
    rbRaw: TTntRadioButton;
    rbMP4: TTntRadioButton;
    rbAVI: TTntRadioButton;
    SaveDialog: TTntSaveDialog;
    cbChapVal: TTntComboBox;
    cbChapVal2: TTntComboBox;
    ToolButton3: TToolButton;
    Playbt: TToolButton;
    Pausebt: TToolButton;
    Stopbt: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    Timer2: TTimer;
    Splitter1: TSplitter;
    TagPanel: TTntPanel;
    lbAlbumSetter: TTntLabel;
    lbArtistSetter: TTntLabel;
    TagPopupMenu: TTntPopupMenu;
    Name2: TTntMenuItem;
    timing: TTntMenuItem;
    Artist1: TTntMenuItem;
    Album1: TTntMenuItem;
    Year1: TTntMenuItem;
    Genre1: TTntMenuItem;
    FPS: TTntMenuItem;
    ype1: TTntMenuItem;
    BrandName1: TTntMenuItem;
    PAR1: TTntMenuItem;
    Delay1: TTntMenuItem;
    chFlat: TTntCheckBox;
    TntLabel3: TTntLabel;
    edTemp: TTntEdit;
    TntImage26: TTntImage;
    OpenDirDialog: TOpenDirDialog;
    ImageListHeader: TImageList;
    rbRawAll: TTntRadioButton;
    chVFR: TTntCheckBox;
    lbSplitat: TTntLabel;
    cbSplitOut: TTntComboBox;
    chHint: TTntCheckBox;
    Indexation: TTntMenuItem;
    lbConcOutput: TTntLabel;
    cbOutputFormat: TTntComboBox;
    TntSplitter1: TTntSplitter;
    InfoSaveDialog: TTntSaveDialog;
    CreationList: TabfImageListBox;
    EditionList: TabfImageListBox;
    SettingsList: TabfImageListBox;
    DSVideoWindowEx21: TDSVideoWindowEx2;
    FilterGraph: TFilterGraph;
    DosCommand: TDosCommand;
    XPManifest1: TXPManifest;
    scFileDrop: TscFileDrop;
    InfoPopupMenu: TTntPopupMenu;
    SaveInfosas1: TTntMenuItem;
    YambForm1: TTntMenuItem;
    MP4BoxForm1: TTntMenuItem;
    Memo2: TMemo;
    AdvTaskDialog: TTntTaskDialog;
    OpenDialog: TTntOpenDialog;
    WHeaderSettingsPage: TJvgWizardHeader;
    WHeaderMuxPage: TJvgWizardHeader;
    WHeaderProcessPage: TJvgWizardHeader;
    WizardHeaderSplitPage: TJvgWizardHeader;
    WizardHeaderConcatPage: TJvgWizardHeader;
    WHeaderExtractPage: TJvgWizardHeader;
    WHeaderOneClickConv: TJvgWizardHeader;
    WHeaderTagPage: TJvgWizardHeader;
    chVerbose: TTntCheckBox;
    PopupLog: TTntPopupMenu;
    ViewLogFile1: TTntMenuItem;
    Full1: TTntMenuItem;
    ByTrack1: TTntMenuItem;
    LsDirTree211: TLsDirTree21;
    SettingsView: TTntTreeView;
    gbTagger: TTntGroupBox;
    lbTaggerLocation: TTntLabel;
    TntImage14: TTntImage;
    edTagger: TTntEdit;
    gbYamb: TTntGroupBox;
    lbProcess: TTntLabel;
    lbLang: TTntLabel;
    cbPriority: TTntComboBox;
    chEnableOnFinish: TTntCheckBox;
    chYambLog: TTntCheckBox;
    chOutputLog: TTntCheckBox;
    cbLang: TTntComboBox;
    chiTunesStyle: TTntCheckBox;
    TntBevel2: TTntBevel;
    More: TTntImage;
    Less: TTntImage;
    Less2: TTntImage;
    More2: TTntImage;
    cbCompliance: TTntComboBox;
    lbCompliance: TTntLabel;
    lbCompliance2: TTntLabel;
    cbCompliance2: TTntComboBox;
    chTaggerorNot: TTntCheckBox;
    chWarningAVC: TTntCheckBox;
    OpenPictureDiag: TTntOpenPictureDialog;
    TntImage25: TTntImage;
    TntStaticText1: TTntStaticText;
    TntLabel4: TTntLabel;
    edName: TTntEdit;
    edArtist: TTntEdit;
    TntLabel5: TTntLabel;
    edAlbum: TTntEdit;
    TntLabel6: TTntLabel;
    edYear: TTntEdit;
    lbYear: TTntLabel;
    TntLabel7: TTntLabel;
    edDuration: TTntEdit;
    spbt1: TTntSpeedButton;
    dpbt2: TTntSpeedButton;
    btTagMore: TTntButton;
    lbGenre: TTntLabel;
    cbGenre: TTntComboBox;
    edPic: TTntEdit;
    FilesTagList: TTntListView;
    procedure FormCreate(Sender: TObject);
    procedure WizardCancelButtonClick(Sender: TObject);
    procedure CreationListMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure WebLinks(Sender: TObject);
    procedure MainListClick(Sender: TObject);
    procedure SettingsPageBackButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure SettingsListClick(Sender: TObject);
    procedure Open2Exe(Sender: TObject);
    procedure SettingsPageNextButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure MuxPageBackButtonClick(Sender: TObject; var Stop: Boolean);
    procedure CreationListDblClick(Sender: TObject);
    procedure ProcessPageBackButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure MuxPageNextButtonClick(Sender: TObject; var Stop: Boolean);
    procedure ProcessPageFinishButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure EditionListDblClick(Sender: TObject);
    procedure SplitPageBackButtonClick(Sender: TObject; var Stop: Boolean);
    procedure chVIdeoPreviewClick(Sender: TObject);
    procedure PlayFile(Filename : String);
    procedure StopbtClick(Sender: TObject);
    procedure k(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure SplitChoice(Sender: TObject);
    procedure edSplitFromKeyPress(Sender: TObject; var Key: Char);
    procedure edSplitToKeyPress(Sender: TObject; var Key: Char);
    procedure edSplitDurationKeyPress(Sender: TObject; var Key: Char);
    procedure ConcatPageBackButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure ExtractPageBackButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure ConverterPageBackButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure TntImage23Click(Sender: TObject);
    procedure edFrameRateKeyPress(Sender: TObject; var Key: Char);
    procedure ConverterPageNextButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure ConverterCmd;
    procedure ExtracterCmd;
    procedure DosCommandTerminated(Sender: TObject; ExitCode: Cardinal);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure chYambLogClick(Sender: TObject);
    procedure chOutputLogClick(Sender: TObject);
    procedure PriorityCommand;
    procedure Timer1Timer(Sender: TObject);
    procedure DSTrackBar1Timer(sender: TObject; CurrentPos,
      StopPos: Cardinal);
    procedure AVIConverterCmd;
    procedure btAddClick(Sender: TObject);
    procedure TntImage21Click(Sender: TObject);
    procedure ExtractListViewClick(Sender: TObject);
    procedure ExtractPageNextButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure DosCommandNewLine(Sender: TObject; NewLine: String;
      OutputType: TOutputType);
    procedure Parse_MP4Box(NewLine: String);
    procedure btAbortClick(Sender: TObject);
    procedure btPropertiesClick(Sender: TObject);
    procedure MuxerCmd;
//    procedure WMDropFiles(Var Mesg: TWMDropFiles); message WM_DROPFILES;
    procedure btMP4OutputClick(Sender: TObject);
    procedure cbSplitOutChange(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure btMoveUpClick(Sender: TObject);
    procedure cbChapChange(Sender: TObject);
    procedure SplitCmd;
    procedure SplitPageNextButtonClick(Sender: TObject; var Stop: Boolean);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure cbLangChange(Sender: TObject);
    procedure CreationListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure MP4ListViewColumnClick(Sender: TObject; Column: TListColumn);
    procedure MP4ListViewCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure TntImage13Click(Sender: TObject);
    procedure PlaybtClick(Sender: TObject);
    procedure PausebtClick(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure SettingsListDblClick(Sender: TObject);
    procedure FilesTagListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure TagCmd;
    procedure Parse_AP(NewLine: String);
    procedure x264VFWCmd;
    procedure TagPageBackButtonClick(Sender: TObject; var Stop: Boolean);
    procedure FilesTagListCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure MP4ListViewColumnRightClick(Sender: TObject;
      Column: TListColumn; Point: TPoint);
    procedure FilesTagListColumnRightClick(Sender: TObject;
      Column: TListColumn; Point: TPoint);
    procedure FilesTagListPopUpMenuClick(Sender: TObject);
    procedure MP4ListViewMenuClick(Sender: TObject);
    procedure TntImage26Click(Sender: TObject);
    procedure rbRawAllClick(Sender: TObject);
    procedure rbRawClick(Sender: TObject);
    procedure rbMP4Click(Sender: TObject);
    procedure rbAVIClick(Sender: TObject);
    procedure MP4ListViewClick(Sender: TObject);
    procedure ConcListViewClick(Sender: TObject);
    procedure btConcAddClick(Sender: TObject);
    procedure btConcRemoveClick(Sender: TObject);
    procedure btMoveDownClick(Sender: TObject);
    procedure btConcMoveUpClick(Sender: TObject);
    procedure btConcMoveDownClick(Sender: TObject);
    procedure btConcPropClick(Sender: TObject);
    procedure ConcListViewColumnRightClick(Sender: TObject;
      Column: TListColumn; Point: TPoint);
    procedure btConcBrowseClick(Sender: TObject);
    procedure JoinCmd;
    procedure ConcatPageNextButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure MP4ListViewCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ConcListViewCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure TagPageNextButtonClick(Sender: TObject; var Stop: Boolean);
    procedure scFileDropDrop(Sender: TObject; X, Y: Integer);
    procedure YambForm1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cbOutputFormatChange(Sender: TObject);
    procedure ViewLogFile1Click(Sender: TObject);
    procedure Full1Click(Sender: TObject);
    procedure ByTrack1Click(Sender: TObject);
    procedure LsDirTree211DirChange(Sender: TObject; SelectedPath: String);
    procedure SettingsViewClick(Sender: TObject);
    procedure MoreClick(Sender: TObject);
    procedure LessClick(Sender: TObject);
    procedure More2Click(Sender: TObject);
    procedure Less2Click(Sender: TObject);
    procedure ReadInfo;
    procedure chTaggerorNotClick(Sender: TObject);
    procedure DosCommand2NewLine(Sender: TObject; NewLine: String;
      OutputType: TOutputType);
    procedure MP4ListViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dpbt2Click(Sender: TObject);
    procedure spbt1Click(Sender: TObject);
    procedure TntStaticText1Click(Sender: TObject);
    procedure edYearKeyPress(Sender: TObject; var Key: Char);
    procedure editComponentChange(Sender: TObject);
    procedure FilesTagCmd;
    procedure btTagMoreClick(Sender: TObject);
    procedure WriteTags2;
    procedure SettingsPageHelpButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure WizardHelpButtonClick(Sender: TObject);
    procedure MuxPageHelpButtonClick(Sender: TObject; var Stop: Boolean);
    procedure ProcessPageHelpButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure SplitPageHelpButtonClick(Sender: TObject; var Stop: Boolean);
    procedure ConcatPageHelpButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure ExtractPageHelpButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure ConverterPageHelpButtonClick(Sender: TObject;
      var Stop: Boolean);
    procedure TagPageHelpButtonClick(Sender: TObject; var Stop: Boolean);
   
  private
    { Private declarations }
    LogMsg : TStrings;
    ini : TIniFile;
    procedure LaunchNextRun;
    procedure StreamsInfo(FileName: WideString);
    procedure StreamsInfo4Extract(FileName: WideString);
    procedure ViewExtractOptions;

    function ChapDetec(FileName: WideString): Boolean;
    function VideoDetec(FileName: WideString): Boolean;
    function CalcTimes(cb: String): Integer;
    function CalcVal(ed: WideString): Integer;
    procedure AddFileTotheList(AudioFile: WideString; FileExtension: WideString);


   public
    { Public declarations }
    job_id, job_t : Integer;
    procedure OGMChap(FileName: WideString);
    procedure CueChap(FileName: WideString);
    procedure LoadIDX(FileName: WideString);
    procedure LoadSubText(FileName: WideString);
    procedure WriteInfo;
    procedure WriteTags;
  end;

var MainForm: TMainForm;
    Muxer, Splitter, AVIConverter, Joiner, Tagger, APTagger, Extracter,
    Converter, Abort, ErrorMsg, x264vfw, customValForSplit, SaveInfos, Debugg,
    VerboseMode, mp4file, rawAVC : Boolean;
    Cmd, x264Cmd, cmt : String;
    YambMsg : WideString;
    Beging_Time, Beging_Time2, myDate : TDateTime;
    ColumnToSort, Count, aa : Integer;
    FilesTagPath :WideString;

const YambVersion = 'Yamb 2.0.0.8';
      YambWebSite = 'http://yamb.unite-video.com';


implementation

{$R *.dfm}
//{$R Yamb.exe.RES}

uses URessources, UProperties, UCustomVal;

procedure TMainForm.FormCreate(Sender: TObject);
begin
//     cbLangChange(Sender);

     Converter := False; Splitter := False; Extracter := False; Joiner := False;
     Muxer := False; Tagger := False; AVIConverter := False; Abort := False;
     ErrorMsg := False;  x264vfw := False;  job_t := 0; customValForSplit := False;
     SaveInfos := False; Debugg := False;  VerboseMode := False;  mp4file := true;
     rawAVC := False;   aa := 1; APTagger := False;
     LogMsg := TStringList.Create;
  //   DragAcceptFiles(Handle, true);
     Application.HintHidePause := 10000;

     // Check the right Font
  //  if IsWindowsVista then SetVistaFonts(Self);
  //   HideAppFormTaskBarButton;
//    myDate := EncodeDate(2007, 08, 03);
 //   Debugg := True;
   // if Debugg then YambMsg := ' '+DateToStr(myDate)+' compile'
  //  else YambMsg := '';
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
     CreationList.ItemIndex := 0;
     EditionList.ItemIndex := 0;
     SettingsList.ItemIndex := 0;
     MainList.ItemIndex := 0;
     SettingsView.Items.Item[0].Selected := True;
  //  CreationList.Color := $FAE6D8;

     { Vista Stylish }
     if isWindowsVista then CreationList.Width := CreationList.Width
     else CreationList.Width := CreationList.Width+5;
     if isWindowsVista then EditionList.Width := EditionList.Width
     else EditionList.Width := EditionList.Width+5;
     if isWindowsVista then MainList.Width := MainList.Width
     else MainList.Width := MainList.Width+5;
     if isWindowsVista then SettingsList.Width := SettingsList.Width
     else SettingsList.Width := SettingsList.Width+5;
     if isWindowsVista then AboutPanel.Width := AboutPanel.Width
     else AboutPanel.Width := AboutPanel.Width+5;

     if isWindowsVista then gbInput.Width := gbInput.Width
     else gbInput.Width := gbInput.Width+5;
     if isWindowsVista then  gbMP4Output.Width := gbMP4Output.Width
     else gbMP4Output.Width := gbMP4Output.Width+5;
     if isWindowsVista then  gbRunningProcess.Width := gbRunningProcess.Width
     else gbRunningProcess.Width := gbRunningProcess.Width+5;
     if isWindowsVista then  gbSplitInput.Width := gbSplitInput.Width
     else gbSplitInput.Width := gbSplitInput.Width+5;
     if isWindowsVista then  gbSplitOptions.Width := gbSplitOptions.Width
     else gbSplitOptions.Width := gbSplitOptions.Width+5;
     if isWindowsVista then  gbConcInput.Width := gbConcInput.Width
     else gbConcInput.Width := gbConcInput.Width+5;
      if isWindowsVista then  gbConcOutput.Width := gbConcOutput.Width
     else gbConcOutput.Width := gbConcOutput.Width+5;
      if isWindowsVista then  gbExtractInput.Width := gbExtractInput.Width
     else gbExtractInput.Width := gbExtractInput.Width+5;
      if isWindowsVista then  gbContent.Width := gbContent.Width
     else gbContent.Width := gbContent.Width+5;
     if isWindowsVista then  gbExtractOptions.Width := gbExtractOptions.Width
     else gbExtractOptions.Width := gbExtractOptions.Width+5;
     if isWindowsVista then  gbConverterInput.Width := gbConverterInput.Width
     else gbConverterInput.Width := gbConverterInput.Width+5;
     if isWindowsVista then  gbSub.Width := gbSub.Width
     else gbSub.Width := gbSub.Width+5;
     if isWindowsVista then  gbAVIOptions.Width := gbAVIOptions.Width
     else gbAVIOptions.Width := gbAVIOptions.Width+5;
     if isWindowsVista then  gbMP4Box.Width := gbMP4Box.Width
     else gbMP4Box.Width := gbMP4Box.Width+5;
     if isWindowsVista then  gbTagger.Width := gbTagger.Width
     else gbTagger.Width := gbTagger.Width+5;
     if isWindowsVista then  gbYamb.Width := gbYamb.Width
     else gbYamb.Width := gbYamb.Width+5;     

     { Auto-detection of MP4Box location }
     if WideFileExists(Tnt_WideLowerCase(WideExtractFilePath(Application.ExeName)+
                       'mp4box.exe')) then
     edMP4Box.Text := Tnt_WideLowerCase(WideExtractFilePath(Application.ExeName)+
                       'mp4box.exe');

     if WideFileExists(WideExtractFilePath(Application.ExeName)+'Yamb.cfg') then
       begin
     { Config }
     try
        ini := TIniFile.Create(WideExtractFilePath(Application.ExeName)+'Yamb.cfg');
        edMP4Box.Text := ini.ReadString('Main', 'MP4Box_path', edMP4Box.Text);
        edTemp.Text := ini.ReadString('Main', 'Tmp_path', edTemp.Text);
        edTagger.Text := ini.ReadString('Main', 'Tagger_path', edTagger.Text);
        if ini.ReadBool('Main', 'SaveLogApp', false) = true then chYambLog.Checked := True
        else chOutputLog.Checked := False;
        if ini.ReadBool('Main', 'SaveLogOut', false) = true then chOutputLog.Checked := True
        else chYambLog.Checked := False;
        if ini.ReadBool('Main', 'ModernStyleList', false) = true then chiTunesStyle.Checked := True
        else chiTunesStyle.Checked := False;
        cbLang.ItemIndex := ini.ReadInteger('Main', 'Lang', cbLang.ItemIndex);
        cbPriority.ItemIndex := ini.ReadInteger('Main', 'Priority', cbPriority.ItemIndex);
        if ini.ReadBool('Main', 'OverwriteOutput', false) = true then chOverwrite.Checked := True
        else chOverwrite.Checked := False;
        if ini.ReadBool('Main', 'KeepAll', false) = true then chKeepSys.Checked := True
        else chKeepSys.Checked := False;
        if ini.ReadBool('Main', 'Flat', false) = true then chFlat.Checked := True
        else chFlat.Checked := False;
        if ini.ReadBool('Main', 'UseItasTagger', false) = true then chTaggerorNot.Checked := True
        else chTaggerorNot.Checked := False;
        if ini.ReadBool('Main', 'Verbose', false) = true then chVerbose.Checked := True
        else chVerbose.Checked := False;
        if ini.ReadBool('Main', 'RaiseWarning4AVC', false) = true then chWarningAVC.Checked := True
        else chWarningAVC.Checked := False;

     finally
        ini.Free;
     end;
        end;
     { Language }
    cbLangChange(Sender);

     { Log Messages }
     if Debugg then
          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+YambVersion+' '+DateToStr(myDate)+' compile '+MsgStarted+' !!!')
     else LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+YambVersion+' '+MsgStarted+' !!!');
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgOSType+SystemVersionText);
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgMP4BoxFound+' %s', [edMP4Box.Text]))
     else LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgMP4BoxMissing);
     if edTagger.Text <> '' then
       begin
            if Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'mp4box.exe'
              then LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgTaggerFound+'%s', [WideExtractFileName(edTagger.Text)]))
         //   else if Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'atomicparsley.exe'
           //   then LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgTaggerFound+'%s', [WideExtractFileName(edTagger.Text)]))
            else LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgTaggerFound+'%s '+MsgTaggerFoundButNotSupported, [WideExtractFileName(edTagger.Text)]));
       end
     else LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgTaggerMissing);

     {    if GetWindowsLanguage(LOCALE_SENGLANGUAGE) = 'French' then
          cbLang.ItemIndex := 0
     else cbLang.ItemIndex := 1;  }

 { LOCALE_ILANGUAGE           // language id 
  LOCALE_SLANGUAGE           // localized name of language
  LOCALE_SENGLANGUAGE        // English name of language
  LOCALE_SABBREVLANGNAME     // abbreviated language name
  LOCALE_SNATIVELANGNAME     // native name of language
 }

    { MP4Box Infos enable/disable in MP4ListView }
    if edMP4Box.Text <> '' then MP4BoxForm1.Enabled := True
    else MP4BoxForm1.Enabled := False;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
     // For Video preview
     FilterGraph.Active := False;
     FilterGraph.Stop;
     FilterGraph.ClearGraph;

     // To be sure
     if DosCommand.Active then DosCommand.Stop;

     if chYambLog.Checked then
       begin
            LogFileExists(Application.ExeName);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
            LogMsg.SaveToFile(WideExtractFilePath(Application.ExeName)+'Yamb.log');
       end
     else if chOutputLog.Checked then
         begin
              if Converter then
                begin
                     LogFileExists(edConvInput.Text);
                     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
                     LogMsg.SaveToFile(WideExtractFilePath(edConvInput.Text)+'Yamb.log');
                     Converter := False;
                end
              else if Extracter then
                begin
                     LogFileExists(edExtractInput.Text);
                     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
                     LogMsg.SaveToFile(WideExtractFilePath(edExtractInput.Text)+'Yamb.log');
                     Extracter := False;
                end
              else if Muxer then
                begin
                     LogFileExists(edMP4Output.Text);
                     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
                     LogMsg.SaveToFile(WideExtractFilePath(edMP4Output.Text)+'Yamb.log');
                     Muxer := False; x264vfw := False;
                end
              else if Joiner then
                begin
                     LogFileExists(edConcOutput.Text);
                     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
                     LogMsg.SaveToFile(WideExtractFilePath(edConcOutput.Text)+'Yamb.log');
                     Joiner := False;
                end
              else if Splitter then
                begin
                     LogFileExists(edSplitInput.Text);
                     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
                     LogMsg.SaveToFile(WideExtractFilePath(edSplitInput.Text)+'Yamb.log');
                     Splitter := False;
                end
              else if Tagger then
                begin
                     LogFileExists(FilesTagList.Selected.SubItems[0]+FilesTagList.Selected.SubItems[1]);
                     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Yclosed, [YambVersion+YambMsg]));
                     LogMsg.SaveToFile(FilesTagList.Selected.SubItems[0]+'Yamb.log');
                     Tagger := False;
                end
         end;

     // Config
     try
        ini := TIniFile.Create(WideExtractFilePath(Application.ExeName)+'Yamb.cfg');
        ini.WriteString('Main', 'MP4Box_path', edMP4Box.Text);
        ini.WriteString('Main', 'Tmp_path', edTemp.Text);
        ini.WriteString('Main', 'Tagger_path', edTagger.Text);
        if chYambLog.Checked then
             ini.WriteBool('Main', 'SaveLogApp', true)
        else ini.WriteBool('Main', 'SaveLogApp', false);
        if chOutputLog.Checked then
             ini.WriteBool('Main', 'SaveLogOut', true)
        else ini.WriteBool('Main', 'SaveLogOut', false);
        if chiTunesStyle.Checked then
             ini.WriteBool('Main', 'ModernStyleList', true)
        else ini.WriteBool('Main', 'ModernStyleList', false); 
        ini.WriteInteger('Main', 'Lang', cbLang.ItemIndex);
        ini.WriteInteger('Main', 'Priority', cbPriority.ItemIndex);
        if chOverwrite.Checked then
             ini.WriteBool('Main', 'OverwriteOutput', true)
        else ini.WriteBool('Main', 'OverwriteOutput', false);
        if chKeepSys.Checked then
             ini.WriteBool('Main', 'KeepAll', true)
        else ini.WriteBool('Main', 'KeepAll', false);
        if chFlat.Checked then
             ini.WriteBool('Main', 'Flat', true)
        else ini.WriteBool('Main', 'Flat', false);
        if chTaggerorNot.Checked then
             ini.WriteBool('Main', 'UseItasTagger', true)
        else ini.WriteBool('Main', 'UseItasTagger', false);
        if chVerbose.Checked then
             ini.WriteBool('Main', 'Verbose', true)
        else ini.WriteBool('Main', 'Verbose', false);
        if chWarningAVC.Checked then
             ini.WriteBool('Main', 'RaiseWarning4AVC', true)
        else ini.WriteBool('Main', 'RaiseWarning4AVC', false);

     finally
        ini.Free;
     end;
end;


//****************************************************************************\\
//                                                                            \\
//****************************************************************************\\

procedure TMainForm.WizardCancelButtonClick(Sender: TObject);
begin
     Application.Terminate;   
end;

procedure TMainForm.CreationListMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var p: TPoint;
begin
     p.x := x;
     p.y := y;
     CreationList.ItemIndex := CreationList.ItemAtPos(P, True);
end;

procedure TMainForm.WebLinks(Sender: TObject);
begin
     Tnt_ShellExecuteW(0, nil, PWideChar((Sender as TTntImage).Hint), nil, nil, SW_NORMAL);
end;

procedure TMainForm.MainListClick(Sender: TObject);
begin
     with MainList do
         case ItemIndex of
             0 : begin // Creation
                      CreationList.Visible := True; EditionList.Visible := False;
                      SettingsList.Visible := False; AboutPanel.Visible := False;
                 end;
             1 : begin // Editing
                      CreationList.Visible := False; EditionList.Visible := True;
                      SettingsList.Visible := False; AboutPanel.Visible := False;
                 end;
             2 : begin  // Settings
                      CreationList.Visible := False; EditionList.Visible := False;
                      SettingsList.Visible := True; AboutPanel.Visible := False;
                 end;
             3 : begin  // About
                      CreationList.Visible := False; EditionList.Visible := False;
                      SettingsList.Visible := False; AboutPanel.Visible := True;
                 end;
         end;
end;

procedure TMainForm.SettingsPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

procedure TMainForm.SettingsListClick(Sender: TObject);
begin
     Wizard.ActivePage := SettingsPage;
end;

//****************************************************************************\\
//                                Settings                                    \\
//****************************************************************************\\
procedure TMainForm.SettingsViewClick(Sender: TObject);
begin
     with SettingsView do
         if Items.Item[0].Selected then
           begin
                gbYamb.Visible := False; gbTagger.Visible := False; gbMP4Box.Visible := True;
           end
         else if Items.Item[1].Selected then
           begin
                gbYamb.Visible := False; gbTagger.Visible := True; gbMP4Box.Visible := False;
           end
         else
           begin
                gbYamb.Visible := True; gbTagger.Visible := False; gbMP4Box.Visible := False;
           end
end;


procedure TMainForm.Open2Exe(Sender: TObject);
begin
     OpenDialog.Filter := 'Executable Files (*.exe)|*.exe';
     if OpenDialog.Execute then
       begin
            edTagger.Text := OpenDialog.FileName;
            if Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'atomicparsley.exe' then
              begin
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(edTagger.Text)]));
                   if chTaggerorNot.Checked then chTaggerorNot.Checked := False;
              end
            else if Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'mp4box.exe' then
                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(edTagger.Text)]))
            else LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Problem...%s '+BadTagger,[WideExtractFileName(edTagger.Text)]));

       end;
end;

procedure TMainForm.TntImage13Click(Sender: TObject);
begin
     OpenDialog.Filter := 'Executable Files (*.exe)|*.exe';
     if OpenDialog.Execute then
       begin
            edMP4Box.Text := OpenDialog.FileName;
            if edMP4Box.Text <> '' then MP4BoxForm1.Enabled := True
            else MP4BoxForm1.Enabled := False;
            if Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe' then
                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(edMP4Box.Text)]))
            else LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Problem...%s '+BadMP4Box,[WideExtractFileName(edMP4Box.Text)]));
       end;
end;

procedure TMainForm.chTaggerorNotClick(Sender: TObject);
begin
     if chTaggerorNot.Checked then
       begin
            if edMP4Box.Text <> '' then edTagger.Text := edMP4Box.Text;
       end
     else
       begin
            if Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) <> 'atomicparsley.exe' then edTagger.Text := '';
       end;
end;

procedure TMainForm.SettingsPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

procedure TMainForm.chYambLogClick(Sender: TObject);
begin
     chOutputLog.Checked := not chYambLog.Checked;
end;

procedure TMainForm.chOutputLogClick(Sender: TObject);
begin
     chYambLog.Checked := not chOutputLog.Checked;
end;

//****************************************************************************\\
//                                MP4/3GP Files Creation                      \\
//****************************************************************************\\
procedure TMainForm.MuxPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

procedure TMainForm.CreationListDblClick(Sender: TObject);
begin
//     MP4ListView.Items.Clear;
  //   edMP4Output.Text := '';
     if MP4ListView.Items.Count = 0 then
       begin
     MuxPage.EnableButton(bkNext, False);
     btMoveUp.Visible := False; btMoveDown.Visible := False; btDelete.Visible := False;
     btProperties.Visible := False;
       end;
     case CreationList.ItemIndex of
         0 : begin
               //   MuxPage.Title.Text := MP4FileCreation;
                  WHeaderMuxPage.Captions.Text := MP4FileCreation;
                  Wizard.ActivePage := MuxPage; mp4file := true;
                  if cbCompliance.Enabled = False then cbCompliance.Enabled := True;
             end;
         1 : begin
                //  MuxPage.Title.Text := GPPFileCreation;
                  WHeaderMuxPage.Captions.Text := GPPFileCreation;
                  Wizard.ActivePage := MuxPage; mp4file := false;
                  if cbCompliance.Enabled = True then cbCompliance.Enabled := False;
             end;
     end;
end;
//****************************************************************************\\
//                                  MP4/3GPP Files Creation                   \\
//****************************************************************************\\
procedure TMainForm.btAddClick(Sender: TObject);
var i: Integer;
    s, s1, s2 : String;
    OPFilter, OPFilter2 : String;
begin
     s := '';
     s1 := 'mp4';  s2 := '3gp';
     OPFilter :=   'All Files supported (*.*)|*.avi;*.mp4;*.m4a;*.m4b;*.mov;*.3gp;*.3g2;*.mpeg;*.mpg;*.vcd;*.vob;*.srt;*.ttxt;*.xml;*.idx;*.txt;*.jpg;*.jpeg;*.qcp;*.ogg;*.ts;*.m4v;*.cmp;*.m1v;*.m2v;*.263;*.h263;*.264;*.h264;*.smv;*.mp2;*.mp3;*.mpa;*.evc;*.amr;*.awb;*.aac;'+
                                                '*.nhnt;*.media;*.info;*.nhml|'+
                          '--- Audio Files ---|*.aac;*.amr;*.awb;*.evc;*.mp3;*.mp2;*.mpa;*.smv|'+
                          '    AAC Files (*.aac)|*.aac|'+
                          '    AMR Files (*.amr;*.awb)|*.amr;*.awb|'+
                          '    EVRC Files (*.evc)|*.evc|'+
                          '    MPEG-1 Audio Files (*mp3;*.mp2)|*.mp3;*.mp2;*.mpa|'+
                          '    SMV Files (*.smv)|*.smv|'+
                          '--- Video Files ---|*.263;*.h263;*.264;*.h264;*.m1v;*.m2v;*.m4v;*.cmp|'+
                          '    H263 Video Files (*.263;*.h263)|*.263;*.h263|'+
                          '    H264 Video Files (*.264;*.h264)|*.264;*.h264|'+
                          '    MPEG-1/2 Raw Files (*.m1v;*.m2v)|*.m1v;*.m2v|'+
                          '    MPEG-4 Raw Files (*.m4v;*.cmp)|*.m4v;*.cmp|'+
                          '--- Container Files ---|*.avi;*.mpeg;*.mpg;*.vcd;*.vob;*.ts;*.mov;*.ogg;*.qcp;*.3gp;*.3g2|'+
                          '    AVI Files (*.avi)|*.avi|'+
                          '    MPEG-PS Files (*.mpeg;*.mpg;*.vcd;*.vob)|*.mpeg;*.mpg;*.vcd;*.vob|'+
                          '    MPEG-TS Files (*.ts)|*.ts|'+
                          '    MOV Files (*.mov)|*.mov|'+
                          '    OGG Files (*.ogg)|*.ogg|'+
                          '    QCP Files (*.qcp)|*.qcp|'+
                          '    3GPP Files (*.3gp;*.3g2)|*.3gp;*.3g2|'+
                          '--- Subtitles Files ---|*.srt;*.ttxt;*.xml;*.idx|'+
                          '    SubRip Files (*.srt)|*.srt|'+
                          '    GPAC TimeText Files (*.ttxt)|*.ttxt|'+
                          '    QuickTime TeXML Files (*.xml)|*.xml|'+
                          '    VobSub Files (*.idx)|*.idx|'+
                          '--- Chapters Files ---|*.txt|'+
                          '    Chapters Files (*.txt)|*.txt|'+
                          '--- Pictures Files ---|*.jpg;*.jpeg|'+
                          '    Pictures Files (*.jpg;*.jpeg)|*.jpeg;*.jpg|'+
                          '--- Extra Files ---|*.nhnt;*.media;*.info;*.nhml|'+
                          '    NHNT Files (*.nhnt;*.media;*.info)|*.nhnt;*.media;*.info|'+
                          '    NHML Files (*.nhml)|*.nhml';

     OPFilter2 :=         'All Files supported (*.*)|*.avi;*.mp4;*.m4a;*.m4b;*.mov;*.3gp;*.3g2;*.mpeg;*.mpg;*.vcd;*.vob;*.srt;*.ttxt;*.xml;*.qcp;*.ts;*.m4v;*.cmp;*.m1v;*.m2v;*.263;*.h263;*.264;*.h264;*.smv;*.mp2;*.mp3;*.mpa;*.evc;*.amr;*.awb;*.aac;|'+
                          '--- Audio Files ---|*.aac;*.amr;*.awb;*.evc;*.mp3;*.mp2;*.mpa;*.smv|'+
                          '    AAC Files (*.aac)|*.aac|'+
                          '    AMR Files (*.amr;*.awb)|*.amr;*.awb|'+
                          '    EVRC Files (*.evc)|*.evc|'+
                          '    MPEG-1 Audio Files (*mp3;*.mp2)|*.mp3;*.mp2;*.mpa|'+
                          '    SMV Files (*.smv)|*.smv|'+
                          '--- Video Files ---|*.263;*.h263;*.264;*.h264;*.m1v;*.m2v;*.m4v;*.cmp|'+
                          '    H263 Video Files (*.263;*.h263)|*.263;*.h263|'+
                          '    H264 Video Files (*.264;*.h264)|*.264;*.h264|'+
                          '    MPEG-1/2 Raw Files (*.m1v;*.m2v)|*.m1v;*.m2v|'+
                          '    MPEG-4 Raw Files (*.m4v;*.cmp)|*.m4v;*.cmp|'+
                          '--- Container Files ---|*.avi;*.mpeg;*.mpg;*.vcd;*.vob;*.ts;*.mov;*.qcp;*.3gp;*.3g2|'+
                          '    AVI Files (*.avi)|*.avi|'+
                          '    MPEG-PS Files (*.mpeg;*.mpg;*.vcd;*.vob)|*.mpeg;*.mpg;*.vcd;*.vob|'+
                          '    MPEG-TS Files (*.ts)|*.ts|'+
                          '    MOV Files (*.mov)|*.mov|'+
                          '    QCP Files (*.qcp)|*.qcp|'+
                          '    3GPP Files (*.3gp;*.3g2)|*.3gp;*.3g2|'+
                          '--- Subtitles Files ---|*.srt;*.ttxt;*.xml|'+
                          '    SubRip Files (*.srt)|*.srt|'+
                          '    GPAC TimeText Files (*.ttxt)|*.ttxt|'+
                          '    QuickTime TeXML Files (*.xml)|*.xml';


     if isWindowsVista then
       begin
            if (mp4file) then
              begin
                   if OpenSaveFileDialog(Handle, s1, OPFilter, ' ', 'Select your File', s, True, True, False, True, False) then
                     begin
                          StreamsInfo(s);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(s)]));
                          if edMP4Output.Text = '' then edMP4Output.Text := WideChangeFileExt(s, '.mp4')
                          else edMP4Output.Text := edMP4Output.Text;
                     end;

             end
            else // 3GPP
             begin
                  if OpenSaveFileDialog(Handle, s2, OPFilter2, ' ', 'Select your File', s, True, True, False, True, False) then
                     begin
                          StreamsInfo(s);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(s)]));
                          if edMP4Output.Text = '' then edMP4Output.Text := WideChangeFileExt(s, '.3gp')
                          else edMP4Output.Text := edMP4Output.Text;
                     end;
             end;
       end
     else  // Non Vista
       begin
            if (mp4file) then
              begin
                   OpenDialog.Filter := OPFilter;
                   OpenDialog.Options := [ofAllowMultiSelect];
                   OpenDialog.FilterIndex := 1;
                   if OpenDialog.Execute then
                      begin
                            for i:=0 to OpenDialog.Files.Count-1 do
                               begin
                                    StreamsInfo(OpenDialog.Files.Strings[i]);
                                    LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(OpenDialog.Files.Strings[i])]));
                                    if edMP4Output.Text = '' then edMP4Output.Text := WideChangeFileExt(OpenDialog.Files.Strings[0], '.mp4')
                                    else edMP4Output.Text := edMP4Output.Text;
                               end;
                     end;
              end
            else // 3GPP
              begin
                   OpenDialog.Filter := OPFilter2;
                   OpenDialog.Options := [ofAllowMultiSelect];
                   OpenDialog.FilterIndex := 1;
                   if OpenDialog.Execute then
                     begin
                          for i:=0 to OpenDialog.Files.Count-1 do
                             begin
                                  StreamsInfo(OpenDialog.Files.Strings[i]);
                                  LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(OpenDialog.Files.Strings[i])]));
                                  if edMP4Output.Text = '' then edMP4Output.Text := WideChangeFileExt(OpenDialog.Files.Strings[0], '.3gp')
                                  else edMP4Output.Text := edMP4Output.Text;
                             end;    
                    end
            end;
      end; // end else for not Vista OS

     btDelete.Visible := True; btMoveUp.Visible := True;
     btMoveDown.Visible := True; btProperties.Visible := True;

     { Check whether or not the Items are checked }
     if CheckListBoxItems(MP4ListView) then MuxPage.EnableButton(bkNext, True)
     else MuxPage.EnableButton(bkNext, False);

     if MP4ListView.Items.Count > 0 then
       begin
            SaveInfosas1.Enabled := True;
            MP4ListView.ItemIndex := 0; 
       end
     else SaveInfosas1.Enabled := False;
end;

procedure TMainForm.btDeleteClick(Sender: TObject);
var Item_List: TListItem;
begin
     if MP4ListView.ItemIndex > -1 then
       begin
            DeleteItemMsg(AdvTaskDialog);
            if AdvTaskDialog.Execute = 100 then
         // if WideMessageDlg(Msg1, mtWarning, [mbYes, mbNo], 0) = mrYes then
          begin
               Item_List := MP4ListView.Selected;
               if Item_List <> nil then Item_List.Delete;
          end;
       end;
end;

procedure TMainForm.btMoveUpClick(Sender: TObject);
begin
     if MP4ListView.Selected <> nil then
       ExchangeItems(MP4ListView,MP4ListView.Selected.Index,MP4ListView.Selected.Index-1);
end;

procedure TMainForm.btMoveDownClick(Sender: TObject);
begin
     if MP4ListView.Selected <> nil then
       ExchangeItems(MP4ListView,MP4ListView.Selected.Index+1,MP4ListView.Selected.Index);
end;

procedure TMainForm.MP4ListViewClick(Sender: TObject);
begin
     if CheckListBoxItems(MP4ListView) then MuxPage.EnableButton(bkNext, True)
     else MuxPage.EnableButton(bkNext, False);
end;

// Enable iTunes Style
procedure TMainForm.MP4ListViewCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
const
  cStripe = $FAE6D8;  // colour of alternate list items
begin
     if chiTunesStyle.Checked then
       begin
  if Odd(Item.Index) then
    // odd list items have green background
    MP4ListView.Canvas.Brush.Color := cStripe
  else
    // even list items have window colour background
    MP4ListView.Canvas.Brush.Color := clWindow;
       end;
end;

procedure TMainForm.btMP4OutputClick(Sender: TObject);
begin
     SaveDialog.Filter := 'MP4 Files (*.mp4)|*.mp4|'+
                          '3GPP Files (*.3gp)|*.3gp';
     if (MuxPage.Title.Text = MuxTitleText) then SaveDialog.FilterIndex := 1
     else SaveDialog.FilterIndex := 2;
     if edMP4Output.Text <> '' then SaveDialog.FileName := WideExtractFileName(edMP4Output.Text);
     if SaveDialog.Execute then
       begin
             if (MuxPage.Title.Text = MP4FileCreation) then
                  edMP4Output.Text := WideChangeFileExt(SaveDialog.FileName, '.mp4')
            else  edMP4Output.Text := WideChangeFileExt(SaveDialog.FileName, '.3gp');
       end;
end;

// Split Output
procedure TMainForm.cbSplitOutChange(Sender: TObject);
begin
     case cbSplitOut.ItemIndex of
         5 :  begin
                   CustomValForSplit := True;
                   CustomVal.edCustomVal.Visible := True;
                  CustomVal.edPAR1.Visible := False;
                  CustomVal.edPAR2.Visible := False;
                  CustomVal.Label1.Visible := False;
                   CustomVal.ShowModal;
              end;
     end;
end;

procedure TMainForm.StreamsInfo(FileName: WideString);
var Handle : Cardinal;
    VideoStreamNb, AudioStreamNb, SubStreamNb : String;
    ListItem : TTntListItem;
    i, j : Integer;
    ListV: TTntListView;
begin
     j := 0;
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     VideoStreamNb := MediaInfo_Get(Handle, 0, 0, 'VideoCount', 1, 0);
     AudioStreamNb := MediaInfo_Get(Handle, 0, 0, 'AudioCount', 1, 0);
     SubStreamNb := MediaInfo_Get(Handle, 0, 0, 'TextCount', 1, 0);
     if Wizard.ActivePage = MuxPage then ListV := MP4ListView
     else ListV := ConcListView;

     if VideoStreamNb <> '0' then
       begin
            if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mov') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3gp') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3g2') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') then
              begin
                   for i:=0 to StrToInt(VideoStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') then
                                ListItem.SubItems.Add(IntToStr(HexToInt(MediaInfo_Get(Handle, 1, i, 'ID', 1, 0))))
                           else ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'Width', 1, 0)+' x '+
                                                 MediaInfo_Get(Handle, 1, i, 'Height', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 1, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Language/String', 1, 0)); // Language
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'FrameRate', 1, 0)); // FrameRate
                           ListItem.SubItems.Add('video'); // Type
                           ListItem.SubItems.Add('');   // BrandName
                           ListItem.SubItems.Add('');  // PAR
                           ListItem.SubItems.Add('');  // HEAAC Signal
                           ListItem.SubItems.Add('');  // Copyright
                           ListItem.SubItems.Add('');  // Delay
                           ListItem.SubItems.Add('');  // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') and
                              (MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0) = 'AVC') then
                             begin
                                  ListItem.Checked := False; Inc(j);
                             end
                           else ListItem.Checked := True;
                      end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpeg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.vob') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m1v') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m2v') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.vcd') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.cmp') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4v') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ogg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.avi') then
              begin
                   for i:=0 to StrToInt(VideoStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add('video'); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'Width', 1, 0)+' x '+
                                                 MediaInfo_Get(Handle, 1, i, 'Height', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 1, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Language/String', 1, 0)); // Language
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'FrameRate', 1, 0)); // FrameRate
                           ListItem.SubItems.Add('video'); // Type
                           ListItem.SubItems.Add('');   // BrandName
                           ListItem.SubItems.Add('');  // PAR
                           ListItem.SubItems.Add('');  // HEAAC Signal
                           ListItem.SubItems.Add('');  // Copyright
                           ListItem.SubItems.Add('');  // Delay
                           ListItem.SubItems.Add('');  // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           if MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0) = 'Intel H.264' then
                             begin
                                  x264vfw := True; job_t :=2;
                                  x264Cmd := '-aviraw video "'+ListItem.SubItems[0]+ListItem.SubItems[1]+'"';
                                  cmt := 'Extraction of '+ListItem.SubItems[1]+' to raw h264...';
                             end
                           else x264vfw := False;
                           ListItem.Checked := True;
                      end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.264') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.h264') then
                begin
                     for i:=0 to StrToInt(VideoStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(''); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'Codec/Info', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'Codec_Profile', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 1, i, 'Width', 1, 0)+' x '+
                                                 MediaInfo_Get(Handle, 1, i, 'Height', 1, 0)); // Description
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Title', 1, 0));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Language/String', 1, 0)); // Language
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'FrameRate', 1, 0)); // FrameRate
                           ListItem.SubItems.Add('video'); // Type
                           ListItem.SubItems.Add('');   // BrandName
                           ListItem.SubItems.Add('');  // PAR
                           ListItem.SubItems.Add('');  // HEAAC Signal
                           ListItem.SubItems.Add('');  // Copyright
                           ListItem.SubItems.Add('');  // Delay
                           ListItem.SubItems.Add('');  // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           ListItem.Checked := True;
                           // Raise a Warning for the FrameRate
                           if chWarningAVC.Checked then rawAVC := True else rawAVC := False;
                      end;
                end;
         end;

     if AudioStreamNb <> '0' then
       begin

            if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4a') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4b') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mov') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3gp') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3g2') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') then
              begin
                   for i:=0 to StrToInt(AudioStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') then
                                ListItem.SubItems.Add(IntToStr(HexToInt(MediaInfo_Get(Handle, 2, i, 'ID', 1, 0))))
                           else ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'Channel(s)', 1, 0)+' Ch - '+
                                                 MediaInfo_Get(Handle, 2, i, 'SamplingRate/String', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 2, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Language/String', 1, 0)); //
                           ListItem.SubItems.Add(''); // FrameRate
                           ListItem.SubItems.Add('audio'); // Type
                           ListItem.SubItems.Add('');    // BrandName
                           ListItem.SubItems.Add('');   // PAR
                           ListItem.SubItems.Add('');   // HEAAC Signal
                           ListItem.SubItems.Add('');    // Copyright
                           ListItem.SubItems.Add('');   // Delay
                           ListItem.SubItems.Add('');   // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           if (MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0) = 'AC3') or
                              (MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0) = 'DTS') then
                             begin
                                  ListItem.Checked := False; Inc(j);
                             end
                           else ListItem.Checked := True;
                      end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.avi') then
              begin
                   for i:=0 to StrToInt(AudioStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add('audio'); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'Channel(s)', 1, 0)+' Ch - '+
                                                 MediaInfo_Get(Handle, 2, i, 'SamplingRate/String', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 2, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Language/String', 1, 0)); //
                           ListItem.SubItems.Add(''); // FrameRate
                           ListItem.SubItems.Add('audio'); // Type
                           ListItem.SubItems.Add('');    // BrandName
                           ListItem.SubItems.Add('');   // PAR
                           ListItem.SubItems.Add('');   // HEAAC Signal
                           ListItem.SubItems.Add('');    // Copyright
                           ListItem.SubItems.Add('');   // Delay
                           ListItem.SubItems.Add('');   // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           if (MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0) = 'AC3') or
                              (MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0) = 'DTS') then
                             begin
                                  ListItem.Checked := False; Inc(j);
                             end
                           else ListItem.Checked := True;
                      end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.aac') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp3') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp2') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ogg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpa') then
              begin
                   for i:=0 to StrToInt(AudioStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(''); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 0, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'Channel(s)', 1, 0)+' Ch - '+
                                                 MediaInfo_Get(Handle, 2, i, 'SamplingRate/String', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 2, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Language/String', 1, 0)); //
                           ListItem.SubItems.Add(''); // FrameRate
                           ListItem.SubItems.Add('audio'); // Type
                           ListItem.SubItems.Add('');    // BrandName
                           ListItem.SubItems.Add('');   // PAR
                           ListItem.SubItems.Add('');   // HEAAC Signal
                           ListItem.SubItems.Add('');    // Copyright
                           ListItem.SubItems.Add('');   // Delay
                           ListItem.SubItems.Add('');   // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           ListItem.Checked := True;
                      end;
              end
            else
              begin
                   for i:=0 to StrToInt(AudioStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(''); // Index or StreamID or StreamType
                                if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.amr') then
                              ListItem.SubItems.Add('AMR - Adaptative Multi-Rate Format - Optimized for Speech Coding')
                           else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.awb') then
                              ListItem.SubItems.Add('AMR-WB - Adaptative Multi-Rate WideBand Format - Optimized for Speech Coding')
                           else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.evc') then
                              ListItem.SubItems.Add('EVRC - Enhanced Variable Rate Codec - Speech codec used by CDMA networks')
                           else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.smv') then
                              ListItem.SubItems.Add('SMV - Selectable Mode Vocoder - Speech Coding Standard used in CDMA-2000 networks'); // Description
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Title', 1, 0));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Language/String', 1, 0)); //
                           ListItem.SubItems.Add(''); // FrameRate
                           ListItem.SubItems.Add('audio'); // Type
                           ListItem.SubItems.Add('');    // BrandName
                           ListItem.SubItems.Add('');   // PAR
                           ListItem.SubItems.Add('');   // HEAAC Signal
                           ListItem.SubItems.Add('');    // Copyright
                           ListItem.SubItems.Add('');   // Delay
                           ListItem.SubItems.Add('');   // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           ListItem.Checked := True;
                      end;
              end;
       end;

     if SubStreamNb <> '0' then
       begin
            if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mov') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3gp') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3g2') then
              begin
                   for i:=0 to StrToInt(SubStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 3, i, 'Codec/Info', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 3, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'Language/String', 1, 0)); //
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'FrameRate', 1, 0)); // FrameRate
                           if MediaInfo_Get(Handle, 3, i, 'Codec/String', 1, 0) = 'VobSub' then
                                  ListItem.SubItems.Add('vobsub')
                           else ListItem.SubItems.Add('sub'); // Type
                           ListItem.SubItems.Add('');   // BrandName
                           ListItem.SubItems.Add('');   // PAR
                           ListItem.SubItems.Add('');   // HEAAC Signal
                           ListItem.SubItems.Add('');   // Copyright
                           ListItem.SubItems.Add('');   // Delay
                           ListItem.SubItems.Add('');   // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           ListItem.Checked := True;
                      end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.avi') then
              begin
                   for i:=0 to StrToInt(SubStreamNb)-1 do
                      begin
                           ListItem := ListV.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add('sub'); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 3, i, 'Codec/Info', 1, 0)); // Description
                           ListItem.SubItems.Add(DecodeUTF8(MediaInfo_Get(Handle, 3, i, 'Title', 1, 0)));  // Name
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'Language/String', 1, 0)); //
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'FrameRate', 1, 0)); // FrameRate
                           if MediaInfo_Get(Handle, 3, i, 'Codec/String', 1, 0) = 'VobSub' then
                                  ListItem.SubItems.Add('vobsub')
                           else ListItem.SubItems.Add('sub'); // Type
                           ListItem.SubItems.Add('');   // BrandName
                           ListItem.SubItems.Add('');   // PAR
                           ListItem.SubItems.Add('');   // HEAAC Signal
                           ListItem.SubItems.Add('');   // Copyright
                           ListItem.SubItems.Add('');   // Delay
                           ListItem.SubItems.Add('');   // Interleave
                           ListItem.SubItems.Add('');  // Keep N-Vops
                           ListItem.SubItems.Add('');  // Font Name
                           ListItem.SubItems.Add('');  // Font Size
                           ListItem.Checked := True;
                      end;
              end;
       end;    

     // Others Video Streams
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.263') or
        (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.h263') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('H.263 - Video Codec by the ITU-T - Low-Bitrate compressed encoding solution for videoconferencing.');
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('video'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;

     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.qcp') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('QCP - Voice Data.');
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('video'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;

     // Others Audio Streams
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.amr') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('AMR - Adaptative Multi-Rate Format - Optimized for Speech Coding');
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('audio'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.awb') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('AMR-WB - Adaptative Multi-Rate WideBand Format - Optimized for Speech Coding');
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('audio'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.evc') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('EVRC - Enhanced Variable Rate Codec - Speech codec used by CDMA networks');
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('audio'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.smv') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('SMV - Selectable Mode Vocoder - Speech Coding Standard used in CDMA-2000 networks'); // Description
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('audio'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;
     // End of Audio Streams

     // Subtitles Streams
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.idx') then
            LoadIDX(FileName);
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.srt') or
        (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.xml') or
        (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ttxt') then
            LoadSubText(FileName);

     // Chapters Streams
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.txt') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('Chapters File.'); // Description
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add('chap'); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;

     // Pictures Files
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.jpeg') or
        (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.jpg') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('JPEG - Picture File Format.'); // Description
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add(''); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;

     // Extra MPEG-4 Extensions
     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.nhml') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('NHML - XML-based description of a media file.'); // Description
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add(''); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;

     if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.nhnt') or
        (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.media') or
        (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.info') then
       begin
            ListItem := ListV.Items.Add;
            ListItem.SubItems.Add(WideExtractFilePath(FileName));
            ListItem.SubItems.Add(WideExtractFileName(FileName));
            ListItem.SubItems.Add(''); // Index or StreamID or StreamType
            ListItem.SubItems.Add('NHNT - Header and a set of access units descriptors for unknown media formats.'); // Description
            ListItem.SubItems.Add('');  // Name
            ListItem.SubItems.Add(''); //
            ListItem.SubItems.Add(''); // FrameRate
            ListItem.SubItems.Add(''); // Type
            ListItem.SubItems.Add('');    // BrandName
            ListItem.SubItems.Add('');   // PAR
            ListItem.SubItems.Add('');   // HEAAC Signal
            ListItem.SubItems.Add('');    // Copyright
            ListItem.SubItems.Add('');   // Delay
            ListItem.SubItems.Add('');   // Interleave
            ListItem.SubItems.Add('');  // Keep N-Vops
            ListItem.SubItems.Add('');  // Font Name
            ListItem.SubItems.Add('');  // Font Size
            ListItem.Checked := True;
       end;          

     MediaInfo_Close(Handle);

     { Warning }
     if j > 0 then
       begin
            if j = 1 then MsgNotCompatible(AdvTaskDialog,1)
            else MsgNotCompatible(AdvTaskDialog,j);
       end;
end;

procedure TMainForm.LoadSubText(FileName: WideString);
var S: TTntStrings;
    ListItem : TTntListItem;
    ListV: TTntListView;

begin
     S := TTntStringList.Create;
     try
        S.LoadFromFile(FileName);
        if Wizard.ActivePage = MuxPage then ListV := MP4ListView
        else ListV := ConcListView;
        ListItem := ListV.Items.Add;
        ListItem.SubItems.Add(WideExtractFilePath(FileName));
        ListItem.SubItems.Add(WideExtractFileName(FileName));
        ListItem.SubItems.Add(''); // Index or StreamID or StreamType

        // Description
        if (Pos('1', S[0]) = 1) and (Pos(':', S[1][3]) = 1) and
           (Pos('-', S[1][15]) = 1) and (Pos('>', S[1][16]) = 1) then
          begin
               ListItem.SubItems.Add('SRT - SubRip Subtitle Format.');
               ListItem.Checked := True;
          end
        else if (Pos('<!-- GPAC 3GPP Text Stream -->', S[1]) = 1) then
          begin
               ListItem.SubItems.Add('TTXT - GPAC TimeText Format.');
               ListItem.Checked := True;
          end
        else if (Pos('<?quicktime type="application/x-quicktime-tx3g"?>', S[1]) = 1) then
            begin
                 ListItem.SubItems.Add('XML - QuickTime TeXML Format.');
                 ListItem.Checked := True;
            end
        else ListItem.Checked := False;

        ListItem.SubItems.Add('');  // Name
        ListItem.SubItems.Add(''); //
        ListItem.SubItems.Add(''); // FrameRate
        ListItem.SubItems.Add('sub'); // Type
        ListItem.SubItems.Add('');    // BrandName
        ListItem.SubItems.Add('');   // PAR
        ListItem.SubItems.Add('');   // HEAAC Signal
        ListItem.SubItems.Add('');    // Copyright
        ListItem.SubItems.Add('');   // Delay
        ListItem.SubItems.Add('');   // Interleave
        ListItem.SubItems.Add('');  // Keep N-Vops
        ListItem.SubItems.Add('');  // Font Name
        ListItem.SubItems.Add('');  // Font Size

      finally
        S.Free;
      end;
end;


procedure TMainForm.LoadIDX(FileName: Widestring);
var S: TTntStrings;
    I, idx : Integer;
    St1: string[2];
    St2: String;
    ListItem : TTntListItem;

begin
    S := TTntStringList.Create;
    try
      S.LoadFromFile(FileName);
      //VobSub idx file?
      if Pos('# VobSub index file, v', S[0]) = 0 then
      begin
           WideMessageDlg(Msg2, mtError, [mbOk], 0);
           Exit;
      end;
      //which version
   //   if StrToIntDef(S[0][23], 5) > 5 then v6plus := True  else v6plus := False;

      //read needed infos
      for I := 0 to S.Count - 1 do
      begin
           if Pos('id: ', S[I]) = 1 then
             begin
                  ListItem := MP4ListView.Items.Add;
                  ListItem.SubItems.Add(WideExtractFilePath(FileName));
                  ListItem.SubItems.Add(WideExtractFileName(FileName));
                  St1 := Copy(S[I], Pos('id: ', S[I]) + 4, 2);
                  St2 := Copy(S[I], Pos('index: ', S[I]) + 7, Length(S[I]) - Pos('index: ', S[I]) - 7 + 1);
                  idx := StrToInt(St2);
                  ListItem.SubItems.Add(IntToStr(idx+1)); // trackID
                  ListItem.SubItems.Add('VobSub - The Same Subtitle Format used on DVDs.'); // Description
                  ListItem.SubItems.Add('');  // Name
                  ListItem.SubItems.Add(Short2FullLanguageName(St1)); // Language
                  ListItem.SubItems.Add(''); // FrameRate
                  ListItem.SubItems.Add('vobsub'); // Type
                  ListItem.SubItems.Add('');   // BrandName
                  ListItem.SubItems.Add('');  // PAR
                  ListItem.SubItems.Add('');  // HEAAC Signal
                  ListItem.SubItems.Add('');  // Copyright
                  ListItem.SubItems.Add('');  // Delay
                  ListItem.SubItems.Add('');  // Interleave
                  ListItem.SubItems.Add('');  // Keep N-Vops
                  ListItem.SubItems.Add('');  // Font Name
                  ListItem.SubItems.Add('');  // Font Size

             end;
             if ((idx >= 0) and (Pos('timestamp:', S[I]) = 1)) then
                  ListItem.Checked := True;
      end;

    finally
      S.Free;
    end;
end;

procedure TMainForm.ReadInfo;
var ListV: TTntListView;
begin
     if Wizard.ActivePage = MuxPage then ListV := MP4ListView
     else ListV := ConcListView;

     if ListV.Selected <> nil then
       begin
            if ListV.Selected.SubItems[4] <> '' then // Name
              begin
                   PropForm.cbTrack.Items.Text := ListV.Selected.SubItems[4];
                   PropForm.cbTrack.ItemIndex := 0;
              end
            else
              begin
                   PropForm.cbTrack.Items.Text := 'Unspecified';
                   PropForm.cbTrack.ItemIndex := 0;
              end;
            if ListV.Selected.SubItems[5] <> '' then // Language
               PropForm.cbLang.ItemIndex := Lang2Nbr(ListV.Selected.SubItems[5])
            else PropForm.cbLang.ItemIndex := 0;
            if ListV.Selected.SubItems[6] <> '' then // Frame-Rate
               PropForm.edFrameRate.Text := ListV.Selected.SubItems[6]
            else PropForm.edFrameRate.Text := '';
            if ListV.Selected.SubItems[7] <> '' then // Type
              begin
                   PropForm.lbFile1.Caption := lbFile+' : '+ListV.Selected.SubItems[1];
                   PropForm.lbInfo1.Caption := lbInfo+' : '+ListV.Selected.SubItems[3];

                   // Enable/Disable Font Features
                   if (ListV.Selected.SubItems[7] <> 'sub') then
                      begin
                           PropForm.lbPAR.Visible := True; PropForm.lbFontName.Visible := False;
                           PropForm.lbInterleave.Visible := True; PropForm.lbFontSize.Visible := False;
                           PropForm.edFontName.Visible := False; PropForm.edFontSize.Visible := False;
                           PropForm.btFont.Visible := False;
                           PropForm.cbPAR.Visible := True; PropForm.chKeepNVop.Visible := True;
                           PropForm.edInterleave.Visible := True;
                           PropForm.lbSBR.Visible := True; PropForm.cbSBR.Visible := True;
                      end
                   else
                      begin
                           PropForm.lbPAR.Visible := False; PropForm.lbFontName.Visible := True;
                           PropForm.lbInterleave.Visible := False; PropForm.lbFontSize.Visible := True;
                           PropForm.edFontName.Visible := True; PropForm.edFontSize.Visible := True;
                           PropForm.btFont.Visible := True;
                           PropForm.cbPAR.Visible := False; PropForm.chKeepNVop.Visible := False;
                           PropForm.edInterleave.Visible := False;
                           PropForm.lbSBR.Visible := False; PropForm.cbSBR.Visible := False;
                      end;

                   if ListV.Selected.SubItems[7] = 'audio' then
                     begin
                          PropForm.lbType1.Caption := lbType+' : '+lbAudioStream;
                          PropForm.chKeepNVop.Enabled := False;
                          PropForm.lbFrameRate.Enabled := False;
                          PropForm.edFrameRate.Enabled := False;
                          PropForm.cbPAR.Enabled := False;
                          PropForm.lbPAR.Enabled := False;
                          if Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) <> '.aac' then
                            begin
                                 PropForm.cbSBR.Enabled := False; PropForm.lbSBR.Enabled := False;
                            end
                          else
                            begin
                                 PropForm.cbSBR.Enabled := True; PropForm.lbSBR.Enabled := True;
                            end;
                     end
                   else if ListV.Selected.SubItems[7] = 'video' then
                     begin
                          PropForm.lbType1.Caption := lbType+' : '+lbVideoStream;
                          if (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.avi') or
                             (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.m4v') or
                             (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.cmp') then
                               PropForm.chKeepNVop.Enabled := True
                          else PropForm.chKeepNVop.Enabled := False;


                          PropForm.cbPAR.Enabled := True; PropForm.lbPAR.Enabled := True;
                          PropForm.cbSBR.Enabled := False; PropForm.lbSBR.Enabled := False;
                          if (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.mp4') or
                             (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.mov') or
                             (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.3gp') or
                             (Tnt_WideLowerCase(WideExtractFileExt(ListV.Selected.SubItems[1])) = '.3g2') then
                            begin
                                 PropForm.lbFrameRate.Enabled := False; PropForm.edFrameRate.Enabled := False;
                                 PropForm.edFrameRate.Text := '';
                            end
                          else
                            begin
                                 PropForm.lbFrameRate.Enabled := True; PropForm.edFrameRate.Enabled := True;
                            end;  
                     end
                   else if (ListV.Selected.SubItems[7] = 'sub') or
                           (ListV.Selected.SubItems[7] = 'vobsub') then
                     begin
                          PropForm.lbType1.Caption := lbType+' : '+lbSubStream;
                          PropForm.cbBrand.Enabled := False; PropForm.lbBrand.Enabled := False;
                          PropForm.cbPAR.Enabled := False; //PropForm.lbPAR.Enabled := False;
                          PropForm.cbSBR.Enabled := False; PropForm.lbSBR.Enabled := False;
                          PropForm.lbFrameRate.Enabled := False; PropForm.edFrameRate.Enabled := False;
                          PropForm.chKeepNVop.Enabled := False;
                     end;
              end;
            if ListV.Selected.SubItems[8] <> '' then // Brand-Name
              begin
                        if ListV.Selected.SubItems[8] = 'mp42' then
                      PropForm.cbBrand.ItemIndex := 1
                   else if ListV.Selected.SubItems[8] = 'avc1' then
                      PropForm.cbBrand.ItemIndex := 2
                   else if ListV.Selected.SubItems[8] = 'ndsm' then
                      PropForm.cbBrand.ItemIndex := 3
                   else if ListV.Selected.SubItems[8] = 'ndsp' then
                      PropForm.cbBrand.ItemIndex := 4
                   else if ListV.Selected.SubItems[8] = 'ndss' then
                      PropForm.cbBrand.ItemIndex := 5
                   else if ListV.Selected.SubItems[8] = 'ndsc' then
                      PropForm.cbBrand.ItemIndex := 6
                   else if ListV.Selected.SubItems[8] = 'ndsh' then
                      PropForm.cbBrand.ItemIndex := 7
                   else if ListV.Selected.SubItems[8] = 'ndxm' then
                      PropForm.cbBrand.ItemIndex := 8
                   else if ListV.Selected.SubItems[8] = 'ndxp' then
                      PropForm.cbBrand.ItemIndex := 9
                   else if ListV.Selected.SubItems[8] = 'ndxs' then
                      PropForm.cbBrand.ItemIndex := 10
                   else if ListV.Selected.SubItems[8] = 'ndxc' then
                      PropForm.cbBrand.ItemIndex := 11
                   else if ListV.Selected.SubItems[8] = 'ndxh' then
                      PropForm.cbBrand.ItemIndex := 12
                   else
                       begin
                            PropForm.cbBrand.Items.Text := MP4ListView.Selected.SubItems[8];
                            PropForm.cbBrand.ItemIndex := 13;
                       end;

                   if CheckListBoxItems(ListV) then
                            begin
                                 if CheckListViewBrandNameItems(ListV, 8) then
                                   begin
                                         PropForm.cbBrand.Enabled := True;
                                        if PropForm.lbBrand.Enabled = False then PropForm.lbBrand.Enabled := True;
                                   end
                                 else
                                   begin
                                        if (PropForm.cbBrand.Enabled = False) and (PropForm.cbBrand.ItemIndex > 0) then
                                          begin
                                               PropForm.cbBrand.Enabled := True; PropForm.lbBrand.Enabled := True;
                                          end
                                        else
                                          begin
                                               PropForm.cbBrand.Enabled := False; PropForm.lbBrand.Enabled := False;
                                          end;
                                   end;
                            end;
              end
            else PropForm.cbBrand.ItemIndex := 0;
           if PropForm.cbTrack.ItemIndex <> 0 then PropForm.cbTrack.ItemIndex := 0;
           // HE-AAC Signal
           if ListV.Selected.SubItems[10] = 'sbr' then PropForm.cbSBR.ItemIndex := 1
           else if ListV.Selected.SubItems[10] = 'sbrx' then PropForm.cbSBR.ItemIndex := 2
           else PropForm.cbSBR.ItemIndex := 0;
           // PAR
           if ListV.Selected.SubItems[9] <> '' then
             begin
                       if ListV.Selected.SubItems[9] = '12:11' then
                        PropForm.cbPAR.ItemIndex := 1
                  else if ListV.Selected.SubItems[9] = '10:11' then
                        PropForm.cbPAR.ItemIndex := 2
                  else if ListV.Selected.SubItems[9] = '16:11' then
                        PropForm.cbPAR.ItemIndex := 3
                  else if ListV.Selected.SubItems[9] = '40:33' then
                        PropForm.cbPAR.ItemIndex := 4
                  else begin
                            PropForm.cbPAR.Text := 'Custom '+ListV.Selected.SubItems[9];
                            PropForm.cbPAR.ItemIndex := PropForm.cbPAR.Items.Count-1;
                       end;
             end;
           // Delay
           if ListV.Selected.SubItems[12] <> '' then
                 PropForm.edDelay.Text := ListV.Selected.SubItems[12]
           else PropForm.edDelay.Text := '';
           // Interleave
           if ListV.Selected.SubItems[13] <> '' then
                PropForm.edInterleave.Text := ListV.Selected.SubItems[13]
           else PropForm.edInterleave.Text := '';
           // Copyright
           if ListV.Selected.SubItems[11] <> '' then
                PropForm.edCopyright.Text := ListV.Selected.SubItems[11]
           else PropForm.edCopyright.Text := '';
           // Keep N-Vops
           if ListV.Selected.SubItems[14] <> '' then
                PropForm.chKeepNVop.Checked := True
           else PropForm.chKeepNVop.Checked := False;
           // Font Name
           if ListV.Selected.SubItems[15] <> '' then
                PropForm.edFontName.Text := ListV.Selected.SubItems[15]
           else PropForm.edFontName.Text := '';
           // Font Size
           if ListV.Selected.SubItems[16] <> '' then
                PropForm.edFontSize.Text := ListV.Selected.SubItems[16]
           else PropForm.edFontSize.Text := '';
       end;
end;

procedure TMainForm.WriteInfo;
var ListV: TTntListView;
begin
     if Wizard.ActivePage = MuxPage then ListV := MP4ListView
     else ListV := ConcListView;

     if ListV.Selected <> nil then
       begin
            // Language
            if PropForm.cbLang.ItemIndex <> 0 then
              ListV.Selected.SubItems[5] := PropForm.cbLang.Text;
            // Brand-Name
            if (PropForm.cbBrand.Text <> 'Unspecified') then
                    case PropForm.cbBrand.ItemIndex of
                        0 : ListV.Selected.SubItems[8] := '';
                        1 : ListV.Selected.SubItems[8] := 'mp42';
                        2 : ListV.Selected.SubItems[8] := 'avc1';
                        3 : ListV.Selected.SubItems[8] := 'ndsm';
                        4 : ListV.Selected.SubItems[8] := 'ndsp';
                        5 : ListV.Selected.SubItems[8] := 'ndss';
                        6 : ListV.Selected.SubItems[8] := 'ndsc';
                        7 : ListV.Selected.SubItems[8] := 'ndsh';
                        8 : ListV.Selected.SubItems[8] := 'ndxm';
                        9 : ListV.Selected.SubItems[8] := 'ndxp';
                       10 : ListV.Selected.SubItems[8] := 'ndxs';
                       11 : ListV.Selected.SubItems[8] := 'ndxc';
                       12 : ListV.Selected.SubItems[8] := 'ndxh';
                       13 : ListV.Selected.SubItems[8] := PropForm.cbBrand.Text;
                    end;

            // Track Name
            if (PropForm.cbTrack.Text <> 'Unspecified') then
              ListV.Selected.SubItems[4] := PropForm.cbTrack.Text;
            // PAR
            if (PropForm.cbPAR.Text <> 'Unspecified') then
              case PropForm.cbPAR.ItemIndex OF
                  0 : ListV.Selected.SubItems[9] := '';
                  1 : ListV.Selected.SubItems[9] := '12:11';
                  2 : ListV.Selected.SubItems[9] := '10:11';
                  3 : ListV.Selected.SubItems[9] := '16:11';
                  4 : ListV.Selected.SubItems[9] := '40:33';
                  5 : ListV.Selected.SubItems[9] := '';
                  else ListV.Selected.SubItems[9] := right('Custom ',PropForm.cbPAR.Text);
              end;
            // SBR Signal
            if (PropForm.cbSBR.ItemIndex <> 0) and (PropForm.cbSBR.Enabled = True) then
              begin
                   if PropForm.cbSBR.ItemIndex = 1 then ListV.Selected.SubItems[10] := 'sbr'
                   else ListV.Selected.SubItems[10] := 'sbrx';
              end;
            // Copyright
            if PropForm.edCopyright.Text <> '' then
              ListV.Selected.SubItems[11] := PropForm.edCopyright.Text;
            // Frame-Rate
            if PropForm.edFrameRate.Text <> '' then
              ListV.Selected.SubItems[6] := PropForm.edFrameRate.Text
            else ListV.Selected.SubItems[6] := '';
            // Delay
            if PropForm.edDelay.Text <> '' then
              ListV.Selected.SubItems[12] := PropForm.edDelay.Text
            else ListV.Selected.SubItems[12] := '';
            // Interleave
            if PropForm.edInterleave.Text <> '' then
              ListV.Selected.SubItems[13] := PropForm.edInterleave.Text
            else ListV.Selected.SubItems[13] := '';
            // Keep N-Vops
            if PropForm.chKeepNVop.Checked then
                ListV.Selected.SubItems[14] := '1'
            else ListV.Selected.SubItems[14] := '';
            // Font Name
            if PropForm.edFontName.Text <> '' then
                ListV.Selected.SubItems[15] := PropForm.edFontName.Text
            else ListV.Selected.SubItems[15] := '';
            // Font Size
            if PropForm.edFontSize.Text <> '' then
                ListV.Selected.SubItems[16] := PropForm.edFontSize.Text
            else ListV.Selected.SubItems[16] := '';
       end;
end;

procedure TMainForm.btPropertiesClick(Sender: TObject);
begin
     if PropForm.chTagSupport.Visible = False then PropForm.chTagSupport.Visible := True;
     PropForm.Tab1.TabVisible := True; if Tagger then Tagger := False;
     if PropForm.Tab2.TabVisible then PropForm.Tab2.TabVisible := False;
     if PropForm.TabPic.TabVisible then propForm.TabPic.TabVisible := False;
     if PropForm.TabMore.TabVisible then PropForm.TabMore.TabVisible := False;
     if MP4ListView.Selected <> nil then
       begin
            if (MP4ListView.Selected.SubItems[7] = 'chap') or
               (MP4ListView.Selected.SubItems[7] = '') then
               begin
                    //
               end
            else
               begin
                    ReadInfo;
                    PropForm.ShowModal;
               end;
       end;
end;

procedure TMainForm.MuxPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
       begin
            if WideFileExists(edMP4Output.Text) then
              begin
                   if (rawAVC) and (PropForm.edFrameRate.Text = '') then
                     begin
                          MsgrawAVC(AdvTaskDialog);
                          if AdvTaskDialog.Execute = 100 then
                            begin
                                 btProperties.OnClick(Sender);
                            end;
                     end
                   else
                     begin
                          OverwriteMsg(AdvTaskDialog, edMP4Output.Text);
                          if AdvTaskDialog.Execute = 100 then
                            begin
                                 chOverWrite.Checked := True;
                                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+MsgOverwritten,[WideExtractFileName(edMP4Output.Text)]));
                                 Wizard.ActivePage := ProcessPage; job_id := 0; Beging_Time := Now;
                                 Timer1.Enabled := True; Stop := True; Muxer := True;
                                 if Tagger then Tagger := False;
                                 if Splitter then Splitter := False;
                                 if Joiner then Joiner := False;
                                 if AVIConverter then AVIConverter := False;
                                 if x264vfw then x264VFWCmd else MuxerCmd;
                                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg3+' %s ',[WideExtractFilePath(edMP4Output.Text)]));
                            end
                          else begin
                                   Wizard.ActivePage := MuxPage;
                                   Stop := True;
                               end;
                     end;
              end
            else begin
                      if (rawAVC) and (PropForm.edFrameRate.Text = '') then
                        begin
                             MsgrawAVC(AdvTaskDialog);
                             if AdvTaskDialog.Execute = 100 then
                               begin
                                    btProperties.OnClick(Sender);
                                    Wizard.ActivePage := MuxPage;
                                    Stop := True;
                               end;
                        end
                      else
                        begin
                             Wizard.ActivePage := ProcessPage; job_id := 0; Beging_Time := Now;
                             Timer1.Enabled := True; Stop := True; Muxer := True;
                             if Tagger then Tagger := False;
                             if Splitter then Splitter := False;
                             if Joiner then Joiner := False;
                             if AVIConverter then AVIConverter := False;
                             if x264vfw then x264VFWCmd else MuxerCmd;
                             LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Msg3+' '+WideExtractFilePath(edMP4Output.Text));
                        end;
                 end;
       end
     else
         begin
              MP4BoxMissingMsg(AdvTaskDialog);
              if AdvTaskDialog.Execute = 100 then
                begin
                     Wizard.ActivePage := MuxPage;
                     Stop := True;
                end;
         end;
end;

procedure TMainForm.TagCmd;
begin
     Tagger := True;
     Cmd := '"'+edTagger.Text+'" "'+edMP4Output.Text+'"';
     Cmd := Cmd+' --overWrite'; // Force Overwriting
     if PropForm.edName.Text <> '' then Cmd := Cmd+' --title "'+PropForm.edName.Text+'"';
     if PropForm.edArtist.Text <> '' then Cmd := Cmd+' --artist "'+PropForm.edArtist.Text+'"';
     if PropForm.edYear.Text <> '' then Cmd := Cmd+' --year "'+PropForm.edYear.Text+'"';
     if PropForm.edWriter.Text <> '' then Cmd := Cmd+' --composer "'+PropForm.edWriter.Text+'"';
     if PropForm.edTrackN1.Text <> '' then Cmd := Cmd+' --tracknum "'+PropForm.edTrackN1.Text;
     if PropForm.edTrackNum2.Text <> '' then Cmd := Cmd+'/'+PropForm.edTrackNum2.Text+'"';
     if PropForm.edAlbum.Text <> '' then Cmd := Cmd+' --album "'+PropForm.edAlbum.Text+'"';
     if PropForm.edDiskNum1.Text <> '' then Cmd := Cmd+' --disk "'+PropForm.edDiskNum1.Text;
     if PropForm.edDiskNum2.Text <> '' then Cmd := Cmd+'/'+PropForm.edDiskNum2.Text+'"';
     if PropForm.edGroup.Text <> '' then Cmd := Cmd+' --grouping "'+PropForm.edGroup.Text+'"';
     if PropForm.edTempo.Text <> '' then Cmd := Cmd+' --bpm "'+PropForm.edTempo.Text+'"';
     if PropForm.edComposer.Text <> '' then Cmd := Cmd+' --composer "'+PropForm.edComposer.Text+'"';
     if PropForm.chCompile.Checked then Cmd := Cmd+' --compilation "true"';
     if PropForm.cbGenre.Text <> '' then Cmd := Cmd+' --genre "'+PropForm.cbGenre.Text+'"';
     if PropForm.MemoComments.Text <> '' then Cmd := Cmd+' --comment "'+PropForm.MemoComments.Text+'"';
     if PropForm.ThumbView.Count > 0 then Cmd := Cmd+' --artwork "'+PropForm.ThumbView.SelectedFile+'"';

     AddMsg(Format('Tagging of %s...', [WideExtractFileName(edMP4Output.Text)]),0);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Tagging of %s...', [WideExtractFileName(edMP4Output.Text)]));
     DosCommand.CommandLine := Cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Command Line used for Tagging : %s', [Cmd]));
     DosCommand.Execute;
     PriorityCommand;
end;

procedure TMainForm.x264VFWCmd;
begin
     // Disable Back/Finish buttons during the Process
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);

     cmd := '"'+edMP4Box.Text+'"';
     cmd := cmd+' '+x264Cmd;
     AddMsg(AVCinAVIDetect,2);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+AVCinAVIDetect);
     AddMsg(cmt,0);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+cmt);
     DosCommand.CommandLine := cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(CmdUsedForExtract+' : %s', [cmd]));
     DosCommand.Execute;
     PriorityCommand;

end;

procedure TMainForm.MuxerCmd;
var i: Integer;
    ListItem : TTntListItem;

begin
     { Disable Back/Finish buttons during the Process }
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);
      if btAbort.Enabled = False then btAbort.Enabled := True;

     { M4Box executable }
     cmd := '"'+edMP4Box.Text+'"';

     { ISMA & iPod & iPhone & PSP compliances }
     if cbCompliance.Enabled then
     case cbCompliance.ItemIndex of
         0 : cmd := cmd;
         1 : cmd := cmd+' -ipod -brand M4VP:1';
         2 : cmd := cmd+' -ipod';
         3 : cmd := cmd+' -isma';
         4 : cmd := cmd+' -psp';
     end;
 
     { Hint for Streaming }
     if chHint.Checked then cmd := cmd+' -hint';

     { Flat Header for Streaming }
     if chFlat.Checked then cmd := cmd+' -flat';

     for i:=0 to MP4ListView.Items.Count-1 do
        begin
             ListItem := MP4ListView.Items.Item[i];
             if ListItem.Checked then
               begin
                    if ListItem.SubItems[8] <> '' then // Brand-Name
                         cmd := cmd+' -brand '+ListItem.SubItems[8]
                    else cmd := cmd;
                    if ListItem.SubItems[13] <> '' then // Interleave
                         cmd := cmd+' -inter '+ListItem.SubItems[13]
                    else cmd := cmd;
                    if ListItem.SubItems[11] <> '' then // Copyright
                         cmd := cmd+' -cprt '+ListItem.SubItems[11]
                    else cmd := cmd;

                    if (ListItem.SubItems[7] <> 'chap') then
                      begin
                           if chVFR.Checked then
                             begin
                                  if ListItem.Index = 0 then cmd := cmd+' -add "'
                                  else cmd := cmd+' -cat "';
                             end
                           else cmd := cmd+' -add "';
                      end
                    else cmd := cmd+' -chap "';

                    if (x264vfw = True) and (ListItem.SubItems[7] = 'video') then
                         cmd := cmd+ListItem.SubItems[0]+WideChangeFileExt(ListItem.SubItems[1],'_video.h264')
                    else cmd := cmd+ListItem.SubItems[0]+ListItem.SubItems[1];  // Path & Files Name

                    if (ListItem.SubItems[2] = '') and (ListItem.SubItems[7] <> '') then
                         cmd := cmd
                    else if (ListItem.SubItems[7] = 'audio') or
                            (ListItem.SubItems[7] = 'video') or
                            (ListItem.SubItems[7] = 'vobsub') then
                         cmd := cmd+'#'+ListItem.SubItems[2]
                    else cmd := cmd; // Ids

                    if ListItem.SubItems[4] <> '' then // Name
                         cmd := cmd+':name='+ListItem.SubItems[4]
                    else cmd := cmd;
                    if ListItem.SubItems[5] <> '' then // Language
                         cmd := cmd+':lang='+Full2ShortLanguageName(ListItem.SubItems[5])
                    else cmd := cmd;
                    if ListItem.SubItems[6] <> '' then // Frame-Rate
                         cmd := cmd+':fps='+ListItem.SubItems[6]
                    else cmd := cmd;
                    if ListItem.SubItems[9] <> '' then // PAR
                         cmd := cmd+':par='+ListItem.SubItems[9]
                    else cmd := cmd;
                    if ListItem.SubItems[10] = 'sbr' then // HE-AAC Signal
                         cmd := cmd+':sbr'
                    else if ListItem.SubItems[10] = 'sbrx' then
                         cmd := cmd+':sbrx'
                    else cmd := cmd;
                    if ListItem.SubItems[12] <> '' then // Delay
                         cmd := cmd+':delay='+ListItem.SubItems[12]
                    else cmd := cmd;
                    if ListItem.SubItems[15] <> '' then // Font Name
                         cmd := cmd+':font='+ListItem.SubItems[15]
                    else cmd := cmd;
                    if ListItem.SubItems[16] <> '' then // Font Size
                         cmd := cmd+':size='+ListItem.SubItems[16]
                    else cmd := cmd;
                    cmd := cmd+'"';
               end;
        end;

     { Split }
     case cbSplitOut.ItemIndex of
         0 : cmd := cmd;
         1 : cmd := cmd+' -splits 716800'; // = 700MB * 1024
         2 : cmd := cmd+' -splits 819200'; // = 800MB * 1024
         3 : cmd := cmd+' -splits 1024000'; // = 1000MB * 1024
         4 : cmd := cmd+' -splits 1433600'; // = 1400MB * 1024
         5 : cmd := cmd+' -splits '+IntToStr(StrToInt(cbSplitOut.Text)*1024); // Custom
     end;

     { Tags }
     if (PropForm.chTagSupport.Checked) and (Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'mp4box.exe') then
       begin
            cmd := cmd+' -itags ';
            if PropForm.edName.Text <> '' then cmd := cmd+SetNameTags(1) else cmd := cmd;
            if PropForm.edArtist.Text <> '' then cmd := cmd+SetArtistTags(1) else cmd := cmd;
            if PropForm.edYear.Text <> '' then cmd := cmd+SetYearTags(1) else cmd := cmd;
            if PropForm.edWriter.Text <> '' then cmd := cmd+SetWriterTags(1) else cmd := cmd;
            if PropForm.edTrackN1.Text <> '' then cmd := cmd+SetTrackPTags(1) else cmd := cmd;
            if PropForm.edTrackNum2.Text <> '' then cmd := cmd+SetTrackTTags(1) else cmd := cmd;
            if PropForm.edAlbum.Text <> '' then cmd := cmd+SetAlbumTags(1) else cmd := cmd;
            if PropForm.edDiskNum1.Text <> '' then cmd := cmd+SetDiskPTags(1) else cmd := cmd;
            if PropForm.edDiskNum2.Text <> '' then cmd := cmd+SetDiskTTags(1) else cmd := cmd;
            if PropForm.edGroup.Text <> '' then cmd := cmd+SetGroupTags(1) else cmd := cmd;
            if PropForm.edTempo.Text <> '' then cmd := cmd+SetTempoTags(1) else cmd := cmd;
            if PropForm.edComposer.Text <> '' then cmd := cmd+SetComposerTags(1) else cmd := cmd;
            if PropForm.cbGenre.Text <> '' then cmd := cmd+SetGenreTags(1) else cmd := cmd;
            if PropForm.edEncoder.Text <> '' then cmd := cmd+SetEncoderTags(1) else cmd := cmd;
            if PropForm.edTool.Text <> '' then cmd := cmd+SetToolTags(1) else cmd := cmd;
            if PropForm.MemoComments.Text <> '' then cmd := cmd+SetCommentsTags(1) else cmd := cmd;
            if PropForm.ThumbView.SelectedFile <> '' then cmd := cmd+SetPictureTags(1) else cmd := cmd;
            if PropForm.chCompile.Checked then cmd := cmd+SetCompileTags(1) else cmd := cmd;
            if PropForm.chGapless.Checked then cmd := cmd+SetGaplessTags(1) else cmd := cmd;
            cmd := cmd+'"';
       end;

     { Temp dir }
     if edTemp.Text <> '' then cmd := cmd+' -tmp "'+edTemp.Text+'"';

     { Verbose Mode }
     if chVerbose.Checked then
       begin
            cmd := cmd+' -v';
            VerboseMode := True;
       end
     else cmd := cmd;

     { 3GPP File or Not }
     if mp4file then cmd := cmd else cmd := cmd+' -3gp';

     { Overwrite }
     if chOverWrite.Checked then cmd := cmd+' -new "'+edMP4Output.Text+'"'
     else cmd := cmd+' "'+edMP4Output.Text+'"'; // Output File Name

     { Add Message to Logfile }
     AddMsg(Format(Msg5+' %s...', [WideExtractFileName(edMP4Output.Text)]),0);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg5+' %s...', [WideExtractFileName(edMP4Output.Text)]));
     DosCommand.CommandLine := cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg6+' : %s', [cmd]));

     { Execute command line & Priorities }
     DosCommand.Execute;
     PriorityCommand;
end;

//****************************************************************************\\
//                                      ETA Events                            \\
//****************************************************************************\\
procedure TMainForm.ProcessPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
          if Muxer then Wizard.ActivePage := MuxPage
     else if Splitter then Wizard.ActivePage := SplitPage
     else if Converter then Wizard.ActivePage := ConverterPage
     else if AVIConverter then Wizard.ActivePage := ConverterPage
     else if Extracter then Wizard.ActivePage := ExtractPage;
     Stop := True;
end;

procedure TMainForm.ProcessPageFinishButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if chEnableOnFinish.Checked then
       begin
            AdvTaskDialog.Title := FinishCaption;
            AdvTaskDialog.Icon := tiQuestion;
            AdvTaskDialog.CustomButtons.Clear;
            AdvTaskDialog.CustomButtons.Add(btYes);
            AdvTaskDialog.CustomButtons.Add(btNo);
            AdvTaskDialog.DefaultButton := 100;
            AdvTaskDialog.Instruction := Msg7;
            AdvTaskDialog.Content := '';
            AdvTaskDialog.ExpandedText := MsgNewTask;
            AdvTaskDialog.ExpandControlText := ClickToHide;
            AdvTaskDialog.CollapsControlText := ClickToSeeMore;
            if AdvTaskDialog.Execute = 100 then Application.Terminate
            else begin
                      if Muxer then
                        begin
                             if MP4ListView.Items.Count > 0 then MP4ListView.Items.Clear;
                             if edMP4Output.Text <> '' then edMP4Output.Text := '';
                        end
                      else if Joiner then
                        begin
                             if ConcListView.Items.Count > 0 then ConcListView.Items.Clear;
                             if edConcOutput.Text <> '' then edConcOutput.Text := '';
                        end
                      else if Extracter then
                        begin
                             if edExtractInput.Text <> '' then edExtractInput.Text := '';
                        end
                      else if Splitter then
                        begin
                             if edSplitInput.Text <> '' then edSplitInput.Text := '';
                        end
                      else if Converter then
                        begin
                             if edConvInput.Text <> '' then edConvInput.Text := '';
                        end
                      else if AVIConverter then
                        begin
                             if edFrameRate.Text <> '' then edFrameRate.Text := '';
                             if edConvInput.Text <> '' then edConvInput.Text := '';
                        end;
                      EraseTagsEdit; // Remove edit areas for the tags                        
                      Wizard.ActivePage := Page1;
                      Stop := True;
                 end;
            {
            if WideMessageDlg(Msg7, mtInformation,[mbYes,mbNo],0) = mrYes then
              Application.Terminate
            else begin
                      if MP4ListView.Items.Count > 0 then MP4ListView.Items.Clear;
                      if edMP4Output.Text <> '' then edMP4Output.Text := '';
                      Wizard.ActivePage := Page1;
                      Stop := True;
                 end;    }
       end
     else Application.Terminate;
end;

procedure TMainForm.btAbortClick(Sender: TObject);
begin
     if Timer1.Enabled then Abort := True;
     if DosCommand.Active then DosCommand.Stop;
end;

//****************************************************************************\\
//                                    Split Events                            \\
//****************************************************************************\\
procedure TMainForm.EditionListDblClick(Sender: TObject);
begin
     With EditionList do
         case ItemIndex of
             0 : Wizard.ActivePage := SplitPage; // Splitter
             1 : Wizard.ActivePage := ConcatPage;  // Joiner
             2 : Wizard.ActivePage := ExtractPage; // Extracter
             3 : Wizard.ActivePage := ConverterPage; // Converter
             4 : Wizard.ActivePage := TagPage;  // Tagger
         end;         
end;

procedure TMainForm.SplitPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

procedure TMainForm.PlayFile(Filename : String);
Begin
     FilterGraph.ClearGraph;

  // --------------------------------------------------------------------------------------
  // This is a workaround the problem that we don't always get the EC_CLOCK_CHANGED.
  // and because we didn't get the EC_CLOCK_CHANGED the DSTrackbar and DSVideoWindowEx1
  // didn't got reassigned and that returned in misfuntions.
     FilterGraph.Active := False;
     FilterGraph.Active := True;
  // --------------------------------------------------------------------------------------
    FilterGraph.RenderFile(FileName);
  //SoundLevel.Position := FilterGraph1.Volume;
    FilterGraph.Play;
    VideoTrackBar.Max := FilterGraph.Duration;
    Beging_Time2 := Now;
    Timer2.Enabled := True;
 // CheckColorControlSupport;
End;

procedure TMainForm.chVIdeoPreviewClick(Sender: TObject);
begin
     ToolBar1.Enabled := chVideoPreview.Checked;
     if (chVideoPreview.Checked) and (edSplitInput.Text <>  '') then
       begin
          //  PlayFile(edSplitInput.Text);
           WideMessageDlg('This is not yet fonctional...sorry', mtInformation, [mbOk], 0, mbOk);
       end;
end;

procedure TMainForm.StopbtClick(Sender: TObject);
begin
     Timer2.Enabled := False;
     FilterGraph.Stop;
     FilterGraph.ClearGraph;
    //  chVideoPreview.Checked := False;
end;

procedure TMainForm.PausebtClick(Sender: TObject);
begin
   //  Timer2.Enabled := False;
     FilterGraph.Pause;
end;


procedure TMainForm.k(Sender: TObject);
var FileS: TFileStream;
    FSize: Cardinal;
    OPFilter : WideString;
    s, s1 :String;
begin
     OPFilter := 'All Files supported (*.*)|*.mp4;*m4a;*.m4b;*.m4v;*.mov;*.3gp;*.3g2|'+
                 'MPEG-4 Files (*.mp4, *.m4a, *.m4b, *.m4v)|*.mp4;*.m4a;*.m4b;*.m4v|'+
                 '3GPP Files (*.3gp, *.3g2)|*.3gp;*.3g2|'+
                 'MOV Files (*.mov)|*.mov';
     s := '';
     s1 := 'mp4';
     if isWindowsVista then
       begin
            if OpenSaveFileDialog(Handle, s1, OPFilter, ' ', 'Select your File', s, True, True, False, True, False) then
              begin
                   edSplitInput.Text := s;  Memo1.Clear; gbSplitOptions.Enabled := True;
              end;
       end
     else   // Non Vista
       begin
            OpenDialog.Filter := OPFilter;
            OpenDialog.FilterIndex := 1;
            if OpenDialog.Execute then
              begin
                   edSplitInput.Text := OpenDialog.FileName;  Memo1.Clear; gbSplitOptions.Enabled := True;
              end;
       end;
       LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded+'...', [WideExtractFileName(edSplitInput.Text)]));
       FileS := TFileStream.Create(edSplitInput.Text, fmOpenRead or fmShareDenyNone);
       FSize := FileS.Size;
       FileS.Free;
       if FSize > 0 then
         begin
              edSplitSize.Text := FormatFileSize(FSize);
              UpDown1.Max := strToInt(edSplitSize.Text);
         end;

       if ChapDetec(edSplitInput.Text) then
         begin
              rbSplitChapN.Enabled := True; rbSplitChapAll.Enabled := True;
         end
       else
         begin
              rbSplitChapN.Enabled := False; rbSplitChapAll.Enabled := False;
         end;
       if VideoDetec(edSplitInput.Text) then chVideoPreview.Enabled := True
       else chVideoPreview.Enabled := False;
       SplitPage.EnableButton(bkNext, True);
end;

procedure TMainForm.SplitChoice(Sender: TObject);
begin
     with Sender as TTnTRadioButton do
     case Tag of
         0 : begin
                  Hint := Split10+#13#10+Split11+#13#10+Split12+#13#10+Split13+#13#10+Split14+#13#10+Split15;
                  edSplitSize.Enabled := rbSize.Checked;
                  UpDown1.Enabled := rbSize.Checked;
                  lbMB.Enabled := rbSize.Checked;
                  edSplitDuration.Enabled := False; edSplitFrom.Enabled := False;
                  edSplitTo.Enabled := False; lbTo.Enabled := False;
                  cbChap.Enabled := False;
            end;

         1 : begin
                  Hint := Split20+#13#10+Split21+#13#10+Split22+#13#10+Split23+#13#10+Split24;
                  edSplitDuration.Enabled := rbDuration.Checked;
                  edSplitFrom.Enabled := False;
                  edSplitTo.Enabled := False; lbTo.Enabled := False;
                  cbChap.Enabled := False; edSplitSize.Enabled := False;
                  UpDown1.Enabled := False; lbMB.Enabled := False;
             end;
         2 : begin
                  Hint := Split30+#13#10+Split31+#13#10+Split32+#13#10+Split33+#13#10+Split34;
                  edSplitFrom.Enabled := rbFrom.Checked;
                  edSplitTo.Enabled := rbFrom.Checked;
                  lbTo.Enabled := rbFrom.Checked; edSplitSize.Enabled := False;
                  UpDown1.Enabled := False; lbMB.Enabled := False;
                  cbChap.Enabled := False; edSplitDuration.Enabled := False;
             end;
         3 : begin
                  Hint := Split40+#13#10+Split41;
                  cbChap.Enabled := rbSplitChapN.Checked;
                  edSplitSize.Enabled := False; edSplitDuration.Enabled := False;
                  UpDown1.Enabled := False; lbMB.Enabled := False;
                  cbChap.Enabled := True; edSplitFrom.Enabled := False;
                  edSplitTo.Enabled := False; lbTo.Enabled := False;
             end;
         4 : begin
                  Hint := Split50+#13#10+Split51;
                  edSplitSize.Enabled := False; cbChap.Enabled := False;
                  UpDown1.Enabled := False; lbMB.Enabled := False;
                  cbChap.Enabled := False; edSplitFrom.Enabled := False;
                  edSplitTo.Enabled := False; lbTo.Enabled := False;
                  edSplitDuration.Enabled := False;
             end;
     end;
end;

function TMainForm.ChapDetec(FileName: WideString): Boolean;
var Handle : Cardinal;
    ChapStream : String;
    i: Integer;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     ChapStream := MediaInfo_Get(Handle, 0, 0, 'ChaptersCount', 1, 0);
     if ChapStream <> '0' then
       begin
            Result := True; cbChap.Clear; cbChapVal.Clear; cbChapVal2.Clear;
            Memo1.Lines.Add(DecodeUTF8(MediaInfo_Get(Handle, 4, 0, 'Inform', 1, 0)));
            for i:=0 to Memo1.Lines.Count-1 do
               begin
                    if i < 9 then
                         cbChap.Items.Add('0'+IntToStr(i+1)+' - '+right('- ',Memo1.Lines.Strings[i]))
                    else cbChap.Items.Add(IntToStr(i+1)+' - '+right('- ',Memo1.Lines.Strings[i]));
                    cbChapVal.Items.Add(lefty(' -',right(': ',Memo1.Lines.Strings[i])));
                    cbChapVal2.Items.Add(lefty(' -',right(': ',Memo1.Lines.Strings[i])));
                    cbChap.ItemIndex := 0; cbChapVal.ItemIndex := 0;
               end;
            cbChap.Items.Delete(Memo1.Lines.Count-1); cbChapVal.Items.Delete(Memo1.Lines.Count-1);
            cbChapVal2.Items.Delete(0);cbChapVal2.Items.Delete(cbChapVal2.Items.Count-1);
            cbChapVal2.Items.Add(MediaInfo_Get(Handle, 0, 0, 'PlayTime/String3', 1, 0)) ;
            cbChapVal2.ItemIndex := 0;
       end
     else Result := False;
     MediaInfo_Close(Handle);
end;

function TMainForm.VideoDetec(FileName: WideString): Boolean;
var Handle : Cardinal;
    VideoStream : String;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     VideoStream := MediaInfo_Get(Handle, 0, 0, 'VideoCount', 1, 0);
     if VideoStream <> '0' then Result := True else Result := False;
     MediaInfo_Close(Handle);
end;

procedure TMainForm.cbChapChange(Sender: TObject);
begin
     cbChapVal.ItemIndex := cbChap.ItemIndex;
     cbChapVal2.ItemIndex := cbChap.ItemIndex;
   //  Label1.Caption := IntToStr(CalcTimes(cbChapVal.Text))+'.'+right('.',cbChapVal.Text);
end;

function TMainForm.CalcTimes(cb: String): Integer;
var hh, mm, ss : string;
begin
     Result := 0;
     if length(cb) > 9 then
       begin
            hh := Copy(cb,0,2); 
            mm := Copy(cb,4,2);
            ss := Copy(cb,7,2);
            Result := StrToInt(hh)*3600+  //hh
                      StrToInt(mm)*60+ //mm
                      StrToInt(ss); //ss
       end;
   {  if length(cb.Text) < 6 then // hh:mm
       Result := StrToInt(lefty(':',cb.Text))*3600+  //hh
                 StrToInt(right(':',lefty(':',cb.Text)))*60; //mm
     if length(cb.Text) < 3 then // hh
       Result := StrToInt(lefty(':',cb.Text))*3600;  }
end;

procedure TMainForm.SplitCmd;
begin
     // Disable Back/Finish buttons during the Process
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);
      if btAbort.Enabled = False then btAbort.Enabled := True;

     cmd := '"'+edMP4Box.Text+'"';
     if rbSize.Checked then
       begin
            cmd := cmd+' -splits '+FloatToStr(StrToFloat(edSplitSize.Text)*1024);
            AddMsg(Format('Split %s into %s MB part...', [WideExtractFileName(edSplitInput.Text), edSplitSize.Text]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Split %s into %s MB part...', [WideExtractFileName(edSplitInput.Text), edSplitSize.Text]));
       end
     else if rbDuration.Checked then
       begin
            cmd := cmd+' -split '+IntToStr(CalcVal(edSplitDuration.Text));
            AddMsg(Format('Split %s each %s ...', [WideExtractFileName(edSplitInput.Text), edSplitDuration.Text]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Split %s each %s ...', [WideExtractFileName(edSplitInput.Text), edSplitDuration.Text]));
       end
     else if rbFrom.Checked then
       begin
            cmd := cmd+' -splitx '+IntToStr(CalcVal(edSplitFrom.Text))+':'+IntToStr(CalcVal(edSplitTo.Text));
            AddMsg(Format('Split %s from %s to %s...', [WideExtractFileName(edSplitInput.Text), edSplitFrom.Text, edSplitTo.Text]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Split %s from %s to %s...', [WideExtractFileName(edSplitInput.Text), edSplitFrom.Text, edSplitTo.Text]));
       end
     else if rbSplitChapN.Checked then
       begin
            cmd := cmd+' -splitx '+IntToStr(CalcTimes(cbChapVal.Text))
                      +'.'+right('.',cbChapVal.Text)+':'+
                      IntToStr(CalcTimes(cbChapVal2.Text))+'.'+
                      right('.',cbChapVal2.Text);
            AddMsg(Format('Split %s at Chapter # %s ...', [WideExtractFileName(edSplitInput.Text), IntToStr(cbChap.ItemIndex+1)]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Split %s at Chapter # %s ...', [WideExtractFileName(edSplitInput.Text), IntToStr(cbChap.ItemIndex+1)]));
       end

     else
      begin
           cmd := cmd+' -splitx '+IntToStr(CalcTimes(cbChapVal.Text))
                      +'.'+right('.',cbChapVal.Text)+':'+
                      IntToStr(CalcTimes(cbChapVal2.Text))+'.'+
                      right('.',cbChapVal2.Text);
            AddMsg(Format('Split %s at Chapter # %s ...', [WideExtractFileName(edSplitInput.Text), IntToStr(cbChap.ItemIndex+1)]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Split %s at Chapter # %s ...', [WideExtractFileName(edSplitInput.Text), IntToStr(cbChap.ItemIndex+1)]));
       end;

     { Verbose Mode }
     if chVerbose.Checked then
       begin
            cmd := cmd+' -v';
            VerboseMode := True;
       end
     else cmd := cmd;

     cmd := cmd+' "'+edSplitInput.Text+'"';
     DosCommand.CommandLine := cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Command Line used for the splitting : %s', [cmd]));
     DosCommand.Execute;
     PriorityCommand;
end;

procedure TMainForm.SplitPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
       begin
            if Muxer then Muxer := False;  Beging_Time := Now;
            Timer1.Enabled := True;
            job_id := 0; if rbSplitChapAll.Checked then job_t := cbChap.Items.Count
            else job_t := 0;
            Splitter := True;
            if Joiner then Joiner := False;
            if AVIConverter then AVIConverter := False;
            if Tagger then Tagger := False;
            if Extracter then Extracter := False;
            if Converter then Converter := False; SplitCmd;
            Wizard.ActivePage := ProcessPage;
            Stop := True;
       end
     else begin
              MP4BoxMissingMsg(AdvTaskDialog);
              if AdvTaskDialog.Execute = 100 then
          //  if WideMessageDlg({Msg41+#13#10+Msg42}Msg4, mtInformation, [mbOk], 0) = mrOk then
         begin
              Wizard.ActivePage := MuxPage;
              Stop := True;
         end;
         end;
end;

procedure TMainForm.edSplitFromKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', ':', '.', Chr(VK_BACK), Chr(VK_DELETE)]) then
     Key := #0;
end;

procedure TMainForm.edSplitToKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', ':', '.', Chr(VK_BACK), Chr(VK_DELETE)]) then
     Key := #0;
end;

procedure TMainForm.edSplitDurationKeyPress(Sender: TObject;
  var Key: Char);
begin
     if not (Key in ['0'..'9', ':', '.', Chr(VK_BACK), Chr(VK_DELETE)]) then
     Key := #0;
end;

procedure TMainForm.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
    // UpDown1.Max := strToInt(lefty(',',edSplitSize.Text));
end;

//****************************************************************************//

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     FilterGraph.Active := False;
     FilterGraph.Stop;
     FilterGraph.ClearGraph;
     if DosCommand.Active then
       begin
            MsgProcessRunning(AdvTaskDialog);
            CanClose := False;
       end
     else
       begin
            DosCommand.Stop; CanClose := True;
       end;
end;

procedure TMainForm.ToolButton7Click(Sender: TObject);
begin
     FilterGraph.Pause;
end;

procedure TMainForm.ToolButton6Click(Sender: TObject);
begin
   //  if not FilterGraph.Active then chVIdeoPreviewClick(nil)
   //  else FilterGraph.play;
end;

//****************************************************************************\\
//                              Concatenation Events                          \\
//****************************************************************************\\
procedure TMainForm.ConcatPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

//****************************************************************************\\
//                              Extraction Events                             \\
//****************************************************************************\\
procedure TMainForm.ExtractPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

//****************************************************************************\\
//                              Converter Events                              \\
//****************************************************************************\\
procedure TMainForm.ConverterPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

procedure TMainForm.TntImage23Click(Sender: TObject);
var Handle : Cardinal;
    OPFilter : WideString;
    s, s1 : String;
begin
     OPFilter :=  'All Files supported (*.*)|*.avi;*.srt;*.ttxt|'+
                  'AVI Files (*.avi)|*.avi|'+
                  'SubRip Files (*.srt)|*.srt|'+
                  'GPAC Text Files (*.ttxt)|*.ttxt';
     s := '';
     s1 := 'avi';

     if isWindowsVista then
       begin
            if OpenSaveFileDialog(Handle, s1, OPFilter, ' ', 'Select your File', s, True, True, False, True, False) then
            edConvInput.Text := s;
       end
     else
       begin
            OpenDialog.Filter := OPFilter;
            OpenDialog.FilterIndex := 1;
            if OpenDialog.Execute then edConvInput.Text := OpenDialog.FileName;
       end;
       LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s loaded.', [WideExtractFileName(edConvInput.Text)]));
       if Tnt_WideLowerCase(WideExtractFileExt(edConvInput.Text)) = '.srt' then
         begin
              rbTTXT.Checked := not rbSRT.Checked;
              gbSub.Enabled := not gbAVIOptions.Enabled;
              rbSRT.Enabled := False; job_t := 1;
              ConverterPage.EnableButton(bkNext, True);
         end
       else if Tnt_WideLowerCase(WideExtractFileExt(edConvInput.Text)) = '.ttxt' then
         begin
              rbSRT.Checked := not rbTTXT.Checked;
              rbTTXT.Enabled := False; job_t := 1;
              gbSub.Enabled := not gbAVIOptions.Enabled;
              ConverterPage.EnableButton(bkNext, True);
         end
       else
         begin
              Handle := MediaInfo_New(); gbSub.Enabled := not gbAVIOptions.Enabled;
              MediaInfo_Open(Handle,PWideChar(edConvInput.Text)); job_t := 2;
              if MediaInfo_Get(Handle, 1, 0, 'Codec/String', 1, 0) = 'Intel H.264' then
               begin
                    edFrameRate.Text := MediaInfo_Get(Handle, 1, 0, 'FrameRate', 1, 0);
                    LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Video Frame-Rate detected: %s fps', [edFrameRate.Text]));
                    ConverterPage.EnableButton(bkNext, True);
               end
             else
               begin
                    MsgNotCompatible(AdvTaskDialog, 0);
                    if edConvInput.Text <> '' then edConvInput.Text := '';
               end;
             MediaInfo_Close(Handle);
         end;
end;

procedure TMainForm.edFrameRateKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edFrameRate.Text) <> 0 then
      Key := #0;
end;

procedure TMainForm.ConverterPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
       begin
            if Muxer then Muxer := False; job_id := 0;
            if Splitter then Splitter := False;
            if Joiner then Joiner := False;
            if AVIConverter then AVIConverter := False;
            if Tagger then Tagger := False;
            if Extracter then Extracter := False;
            Converter := True; ConverterCmd;
            Wizard.ActivePage := ProcessPage;
            Stop := True;
       end
     else begin
              MP4BoxMissingMsg(AdvTaskDialog);
              if AdvTaskDialog.Execute = 100 then
                begin
                     Wizard.ActivePage := MuxPage;
                     Stop := True;
                end;
         end;
end;

procedure TMainForm.ConverterCmd;
begin
     // Disable Back/Finish buttons during the Process
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);
      if btAbort.Enabled = False then btAbort.Enabled := True;

     cmd := '"'+edMP4Box.Text+'"';
     if rbTTXT.Checked then
       begin
            cmd := cmd+' -ttxt';
            AddMsg(Format('Conversion of %s to ttxt format...', [WideExtractFileName(edConvInput.Text)]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Conversion of %s to ttxt format...', [WideExtractFileName(edConvInput.Text)]));
       end
     else if rbSRT.Checked then
       begin
            cmd := cmd+' -srt';
            AddMsg(Format('Conversion of %s to srt format...', [WideExtractFileName(edConvInput.Text)]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Conversion of %s to srt format...', [WideExtractFileName(edConvInput.Text)]));
       end
     else
       begin
            cmd := cmd+' -aviraw video';
            AddMsg(Format('Extraction of %s to raw h264...', [WideExtractFileName(edConvInput.Text)]),0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Extraction of %s to raw h264...', [WideExtractFileName(edConvInput.Text)]));
       end;

     { Verbose Mode }
     if chVerbose.Checked then
       begin
            cmd := cmd+' -v';
            VerboseMode := True;
       end
     else cmd := cmd;  

     cmd := cmd+' "'+edConvInput.Text+'"';
     DosCommand.CommandLine := cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Command Line used for the conversion : %s', [cmd]));
     DosCommand.Execute;
     PriorityCommand;
end;

procedure TMainForm.AVIConverterCmd;
begin
     // Disable Back/Finish buttons during the Process
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);

     cmd := '"'+edMP4Box.Text+'"';
     cmd := cmd+' -add "'+WideChangeFileExt(edConvInput.Text, '_video.h264')+':fps='+edFrameRate.Text+'" "'+
                          WideChangeFileExt(edConvInput.Text, '.mp4')+'"';
     DosCommand.CommandLine := cmd;
     AddMsg(Format('Mux %s to mp4...', [WideExtractFileName(WideChangeFileExt(edConvInput.Text, '_video.h264'))]),0);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Mux %s to mp4...', [WideExtractFileName(WideChangeFileExt(edConvInput.Text, '_video.h264'))]));
     DosCommand.Execute;
     PriorityCommand;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('Command Line used for the mux : %s', [cmd]));
end;



//*****************************************************************************\\


//*****************************************************************************\\
//                                  Process Events                             \\
//*****************************************************************************\\
procedure TMainForm.LaunchNextRun;
var SearchRec: TSearchRec;
begin
     if job_id < job_t then
       begin
            if edFrameRate.Text <> '' then AVIConverterCmd;
            if Splitter then
              begin
                   cbChap.ItemIndex := cbChap.ItemIndex+1;
                   cbChapVal.ItemIndex := cbChapVal.ItemIndex+1;
                   cbChapVal2.ItemIndex := cbChapVal2.ItemIndex+1;
                   SplitCmd;
              end;
            if Muxer then
              begin
                    MuxerCmd;
              end;
            if Extracter then
              begin
                   ExtractListView.ItemIndex := ExtractListView.ItemIndex+1;
                   ExtractListView.Items.Item[ExtractListView.ItemIndex].Selected;
                   ExtracterCmd;
              end;
            if Tagger then
              begin
                   FilesTagList.ItemIndex := FilesTagList.ItemIndex+1;
                   FilesTagList.Items.Item[FilesTagList.ItemIndex].Selected;
                   FilesTagCmd;
              end;
       end
     else
       begin
            if Converter then
              begin
                   if WideFileExists(WideChangeFileExt(edConvInput.Text, '_video.h264')) then
                      WideDeleteFile(WideChangeFileExt(edConvInput.Text, '_video.h264'));
                   if Abort then
                     begin
                          AddMsg(ConvAborted, 2);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ConvAborted);
                          Abort := False;
                     end
                   else if ErrorMsg then
                     begin
                          AddMsg(ConvFailed, 1);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ConvFailed);
                          ErrorMsg := False;
                     end
                   else
                     begin
                          AddMsg(ConvSucceed, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ConvSucceed);
                     end;
              end;
            if Extracter then
              begin
                   if Abort then
                     begin
                          AddMsg(ExtractAborted, 2);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ExtractAborted);
                          Abort := False;
                     end
                   else if ErrorMsg then
                     begin
                          AddMsg(ExtractFailed, 1);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ExtractFailed);
                          ErrorMsg := False;
                     end
                   else
                     begin
                          AddMsg(ExtractSucceed, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ExtractSucceed);
                     end;
              end;
            if Joiner then
              begin
                   if Abort then
                     begin
                          AddMsg(ConcatAborted, 2);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ConcatAborted);
                          Abort := False;
                     end
                   else if ErrorMsg then
                     begin
                          AddMsg(ConcatFailed, 1);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ConcatFailed);
                          ErrorMsg := False;
                     end
                   else
                     begin
                          AddMsg(ConcatSucceed, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ConcatSucceed);
                     end;

              end;
            if Muxer then
              begin
                   if (FindFirst(WideExtractFilePath(edMP4Output.Text)+'\*_video.'+Tnt_WideLowerCase('h264'),faAnyFile,SearchRec) = 0) then
                    begin
                          repeat WideDeleteFile(WideExtractFilePath(edMP4Output.Text)+'\'+SearchRec.Name);
                          until  FindNext(SearchRec) <> 0;
                    end;
                  FindClose(SearchRec);

                   if Abort then
                     begin
                          AddMsg(CreateAborted, 2);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+CreateAborted);
                          Abort := False;
                     end
                   else if ErrorMsg then
                     begin
                          AddMsg(CreateFailed, 1);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+CreateFailed);
                          ErrorMsg := False;
                     end
                   else
                     begin
                          AddMsg(CreateSucceed, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+CreateSucceed);
                     end;
                  if (PropForm.chTagSupport.Checked) and (Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'atomicparsley.exe') then
                     begin
                          Sleep(2000); TagCmd;
                     end;
              end;
            if Splitter then
              begin
                   if Abort then
                     begin
                          AddMsg(SplitAborted, 2);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+SplitAborted);
                     end
                   else if ErrorMsg then
                     begin
                          AddMsg(SplitFailed, 1);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+SplitFailed);
                          ErrorMsg := False;
                     end
                   else
                     begin
                          AddMsg(SplitSucceed, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+SplitSucceed);
                     end;
                   if cbChap.ItemIndex <> 0 then cbChap.ItemIndex := 0;
                   if cbChapVal.ItemIndex <> 0 then cbChapVal.ItemIndex := 0;
                   if cbChapVal2.ItemIndex <> 0 then cbChapVal2.ItemIndex := 0;  
              end;
            if Tagger then
              begin
                   if Abort then
                     begin
                          AddMsg(TagAborted, 2);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+TagAborted);
                     end
                   else if ErrorMsg then
                     begin
                          AddMsg(TagFailed, 1);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+TagFailed);
                          ErrorMsg := False;
                     end
                   else
                     begin
                          AddMsg(TagSucceed, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+TagSucceed);
                     end;
                end;  

            ETAListView.Items[ETAListView.Items.Count-1].MakeVisible(true);

      //      if DosCommand.Active then DosCommand.Stop;

            { Some cleanup }
            if ProgressBar.Position <> 0 then ProgressBar.Position := 0;
            lbPercent.Caption := '0 %'; lbTimeRemaining.Caption := '00:00:00';
            if Application.Title <> 'Yamb' then Application.Title := 'Yamb';

            { Stop the Timer }
            Timer1.Enabled := False;

            { Enable Back/Next buttons at the end of the Process }
            ProcessPage.EnableButton(bkFinish, True);
            ProcessPage.EnableButton(bkBack, True);
            btAbort.Enabled := False;

            { Enabled Log View }
            ViewLogFile1.Enabled := True;
       end;
end;

procedure TMainForm.DosCommandNewLine(Sender: TObject; NewLine: String;
  OutputType: TOutputType);
begin
  //   Memo2.Lines.Add(NewLine);
     if APTagger then Parse_AP(NewLine)
     else if SaveInfos then Memo2.Lines.Add(NewLine)
     else Parse_MP4Box(NewLine);
end;

procedure TMainForm.DosCommandTerminated(Sender: TObject;
  ExitCode: Cardinal);
begin
     if SaveInfos = False then
       begin
            job_id := job_id+1;
            LaunchNextRun;
       end
     else SaveInfos := False;
end;

procedure TMainForm.Parse_AP(NewLine: String);
var pct: String;
begin
     pct := lefty('%',right('=>',NewLine));
     if pct <> '' then
       begin
            ProgressBar.Position := StrToInt(pct);
            lbPercent.Caption := pct+' %';
            ETAListView.Items[ETAListView.Items.Count-1].MakeVisible(true);
            Application.Title := lbPercent.Caption+' - Yamb';
       end;
end;


procedure TMainForm.Parse_MP4Box(NewLine: String);
var pct : String;
begin
     pct := right('| (',lefty('/100)',NewLine));
     if pct <> '' then
       begin
            ProgressBar.Position := StrToInt(pct);
            lbPercent.Caption := pct+' %';
            ETAListView.Items[ETAListView.Items.Count-1].MakeVisible(true);
            Application.Title := lbPercent.Caption+' - Yamb';
       end;

     if Pos('Importing AVI Video: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportAVIVideo, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportAVIVideo);
       end;
     if Pos('Importing AVI Audio: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportAVIAudio, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportAVIAudio);
       end;
     if Pos('ISO File Writing: |                    | (01/100)', NewLine) = 1 then
       begin
            if (PropForm.chTagSupport.Checked) and (Tnt_WideLowerCase(WideExTractFileName(edTagger.Text)) = 'mp4box.exe') then
              begin
                   AddMsg(FileTag, 0);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+FileTag);
                   AddMsg(FileW, 0);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+FileW);
              end
            else
              begin
                   AddMsg(FileW, 0);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+FileW);
              end;
       end;
    if Pos('ISO File Export: |                    | (01/100)', NewLine) = 1 then
        begin
            AddMsg(FileI, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+FileI);
       end;
 {    if Pos('Media Export: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg('File Exporting...', 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : File Exporting...');
       end;  }
     if Pos('Splitting: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(FileS, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+FileS);
       end;
     if Pos('Appending: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(FileA, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+FileA);
       end;
     if Pos('Importing VobSub: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportVobsubFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportVobsubFile);
       end;
     if Pos('Importing ISO File: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportISOFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportISOFile);
       end;
     if Pos('Importing SRT: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportSRTFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportSRTFile);
       end;
     if Pos('Importing TTXT: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportTTXTFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportTTXTFile);
       end;
     if Pos('Importing AAC: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportAACFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportAACFile);
       end;
     if Pos('Importing Image: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportImageFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportImageFile);
       end;
     if right('Storing split-file', NewLine) <> '' then
       begin
            AddMsg(StoringFile+right('Storing split-file', NewLine), 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+StoringFile+right('Storing split-file', NewLine));
       end;
     if Pos('Importing M4V: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportM4VFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportM4VFile);
       end;
     if Pos('Importing MPEG-PS Video: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportPSVideoFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportPSVideoFile);
       end;
     if Pos('Importing MPEG-PS Audio: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportPSAudioFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportPSAudioFile);
       end;
     if Pos('Importing MPEG-2 TS: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportTSFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportTSFile);
       end;
     if Pos('Importing MP3: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportMP3File, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportMP3File);
       end;
     if Pos('Importing AVC-H264: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportAVCFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportAVCFile);
       end;
     if Pos('Importing NHNT: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportNHNTFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportNHNTFile);
       end;
     if Pos('Importing NHML: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportNHMLFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportNHMLFile);
       end;
     if Pos('Importing AMR: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportAMRFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportAMRFile);
       end;
     if Pos('Importing EVRC: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportEVRCFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportEVRCFile);
       end;
     if Pos('Importing SMV: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportSMVFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportSMVFile);
       end;
     if Pos('Importing AMR-WB: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportAMRWBFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportAMRWBFile);
       end;
     if Pos('Importing QCP: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportQCPFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportQCPFile);
       end;
     if Pos('Importing H263: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportH263File, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportH263File);
       end;
     if Pos('Importing OGG Video: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportOGGVideo, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportOGGVideo);
       end;
     if Pos('Importing OGG Audio: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportOGGAudio, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportOGGAudio);
       end;
     if Pos('Importing SAF: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportSAFFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportSAFFile);
       end;
     if Pos('Importing TeXML: |                    | (01/100)', NewLine) = 1 then
       begin
            AddMsg(ImportTeXMLFile, 0);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+ImportTeXMLFile);
       end;
     if right('Unknown PID ',NewLine) <> '' then
       begin
            ErrorMsg := True;
            AddMsg(UnknownPID, 1);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+UnknownPID);
       end;
     if right('Invalid UTF data', NewLine) <> '' then
       begin
            ErrorMsg := True;
            AddMsg(InvalidUTF, 1);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+InvalidUTF+lefty('|',right('UTF data ', NewLine)));
       end;
     if right('Error ', NewLine) <> '' then
       begin
            ErrorMsg := True;
            AddMsg(MsgError, 1);
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : Error '+right('Error ', NewLine));
       end;

     if VerboseMode then
       begin
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+NewLine);
       end;
end;


procedure TMainForm.PriorityCommand;
begin
     case cbPriority.ItemIndex of
         0 : // Real
             begin
                  DosCommand.Priority := REALTIME_PRIORITY_CLASS;
                  SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
             end;
         1 : // Highest
             begin
                  DosCommand.Priority := HIGH_PRIORITY_CLASS;
                  SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);
             end;
         2 : // High
             begin
                  DosCommand.Priority := $8000;
                  SetPriorityClass(GetCurrentProcess(), $8000);
              end;
         3 : // Normal
              begin
                   DosCommand.Priority := NORMAL_PRIORITY_CLASS;
                   SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
              end;
         4 : // Low
              begin
                   DosCommand.Priority := $4000;
                   SetPriorityClass(GetCurrentProcess(), $4000);
              end;
         5 : // Lowest
              begin
                   DosCommand.Priority := IDLE_PRIORITY_CLASS;
                   SetPriorityClass(GetCurrentProcess(), IDLE_PRIORITY_CLASS);
              end;
      end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var elapsed, estimated: double;
begin
     //     VideoTrackBar.Position := MilliSecondsBetween(Now, Beging_Time);
   //  edSplitDuration.Text := FormatDateTime('hh:nn:ss',Now-Beging_Time);

     elapsed := MilliSecondSpan(Now,Beging_Time);
     if ProgressBar.Position = 0 then estimated := 0
     else estimated := (elapsed*(ProgressBar.Max-ProgressBar.Position))/ProgressBar.Position;
  //   ProgressFrame1.lbElapsedVal.Caption := FormatDateTime('hh:nn:ss',Now-Begin_Time);
   //  StatusBar.Panels[0].Text := TimeElapsed+FormatDateTime('hh:nn:ss',Now-Begin_Time);
   //  StatusBar.Update;
     lbTimeRemaining.Caption := FormatDateTime('hh:nn:ss',(estimated+1000)/msecsperday);
end;

procedure TMainForm.DSTrackBar1Timer(sender: TObject; CurrentPos,
  StopPos: Cardinal);
begin
    // edSplitDuration.Text := TimeToStr(CurrentPos /86400000);
end;

//****************************************************************************\\
//                          Extraction Part                                   \\
//****************************************************************************\\
procedure TMainForm.TntImage21Click(Sender: TObject);
var OPFilter : WideString;
    s, s1 :String;
begin
     OPFilter := 'All Files supported (*.*)|*.avi;*.mp4;*m4a;*.m4b;*.mov;*.3gp;*.3g2;*.mpg;*.mpeg;*.vcd;*.vob;*.ts|'+
                 'AVI Files (*.avi)|*.avi|'+
                 'MPEG-PS Files (*.mpg, *.mpeg, *.vob, *.vcd)|*.mpeg;*.mpg;*.vcd;*.vob|'+
                 'MPEG-TS Files (*.ts)|*.ts|'+
                 'MP4 Files (*.mp4, *.m4a, *.m4b)|*.mp4;*.m4a;*.m4b|'+
                 'MOV Files (*.mov)|*.mov|'+
                 '3GPP Files (*.3gp, *.3g2)|*.3gp;*.3g2';
     s := '';
     s1 := 'mp4';

     if isWindowsVista then
       begin
            if OpenSaveFileDialog(Handle, s1, OPFilter, ' ', 'Select your File', s, True, True, False, True, False) then
              begin
                   ExtractListView.Clear;
                   edExtractInput.Text := s;
              end;
       end
     else // Non Vista
       begin
            OpenDialog.Filter := OPFilter;
            OpenDialog.FilterIndex := 1;
            if OpenDialog.Execute then
              begin
                   ExtractListView.Clear;
                   edExtractInput.Text := OpenDialog.FileName;
              end;
       end;
     StreamsInfo4Extract(edExtractInput.Text);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s loaded.', [WideExtractFileName(edExtractInput.Text)]));
end;

procedure TMainForm.StreamsInfo4Extract(FileName: WideString);
var Handle : Cardinal;
    VideoStreamNb, AudioStreamNb, SubStreamNb, ChapStreamNb : String;
    ListItem : TTntListItem;
    i,j : Integer;
begin
     Handle := MediaInfo_New();
     MediaInfo_Open(Handle,PWideChar(FileName));
     VideoStreamNb := MediaInfo_Get(Handle, 0, 0, 'VideoCount', 1, 0);
     AudioStreamNb := MediaInfo_Get(Handle, 0, 0, 'AudioCount', 1, 0);
     SubStreamNb := MediaInfo_Get(Handle, 0, 0, 'TextCount', 1, 0);
     ChapStreamNb := MediaInfo_Get(Handle, 0, 0, 'ChaptersCount', 1, 0);
  
     if VideoStreamNb <> '0' then
       begin
            if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4a') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4b') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mov') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3gp') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3g2') then
              begin
                   for i:=0 to StrToInt(VideoStreamNb)-1 do
                    begin
                         ListItem := ExtractListView.Items.Add;
                         ListItem.SubItems.Add(WideExtractFilePath(FileName));
                         ListItem.SubItems.Add(WideExtractFileName(FileName));
                         ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                         ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'PlayTime/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'BitRate/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'Width', 1, 0)+' x '+
                                               MediaInfo_Get(Handle, 1, i, 'Height', 1, 0)); // Description
                         ListItem.SubItems.Add('video'); // Type
                    end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') then
             begin
                  for i:=0 to StrToInt(VideoStreamNb)-1 do
                    begin
                         ListItem := ExtractListView.Items.Add;
                         ListItem.SubItems.Add(WideExtractFilePath(FileName));
                         ListItem.SubItems.Add(WideExtractFileName(FileName));
                         ListItem.SubItems.Add(IntToStr(HexToInt(MediaInfo_Get(Handle, 1, i, 'ID', 1, 0)))); // Index or StreamID or StreamType
                         ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'PlayTime/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'BitRate/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'Width', 1, 0)+' x '+
                                               MediaInfo_Get(Handle, 1, i, 'Height', 1, 0)); // Description
                         ListItem.SubItems.Add('video'); // Type
                    end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.avi') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpeg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.vcd') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.vob') then
              begin
                   for i:=0 to StrToInt(VideoStreamNb)-1 do
                    begin
                         ListItem := ExtractListView.Items.Add;
                         ListItem.SubItems.Add(WideExtractFilePath(FileName));
                         ListItem.SubItems.Add(WideExtractFileName(FileName));
                         ListItem.SubItems.Add('video'); // Index or StreamID or StreamType
                         ListItem.SubItems.Add(MediaInfo_Get(Handle, 1, i, 'Codec/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'PlayTime/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'BitRate/String', 1, 0)+' - '+
                                               MediaInfo_Get(Handle, 1, i, 'Width', 1, 0)+' x '+
                                               MediaInfo_Get(Handle, 1, i, 'Height', 1, 0)); // Description
                         ListItem.SubItems.Add('video'); // Type
                    end;
              end;
         end;

     if AudioStreamNb <> '0' then
       begin
            if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4a') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.m4b') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mov') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3gp') or
               (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.3g2') then
              begin
                   for i:=0 to StrToInt(AudioStreamNb)-1 do
                      begin
                           ListItem := ExtractListView.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'Channel(s)', 1, 0)+' Ch - '+
                                                 MediaInfo_Get(Handle, 2, i, 'SamplingRate/String', 1, 0)); // Description
                           ListItem.SubItems.Add('audio'); // Type
                     end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.ts') then
             begin
                  for i:=0 to StrToInt(AudioStreamNb)-1 do
                    begin
                         ListItem := ExtractListView.Items.Add;
                         ListItem.SubItems.Add(WideExtractFilePath(FileName));
                         ListItem.SubItems.Add(WideExtractFileName(FileName));
                         ListItem.SubItems.Add(IntToStr(HexToInt(MediaInfo_Get(Handle, 2, i, 'ID', 1, 0)))); // Index or StreamID or StreamType
                         ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'Channel(s)', 1, 0)+' Ch - '+
                                                 MediaInfo_Get(Handle, 2, i, 'SamplingRate/String', 1, 0)); // Description
                           ListItem.SubItems.Add('audio'); // Type
                     end;
              end
            else if (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.avi') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpeg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mpg') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.vcd') or
                    (Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.vob') then
              begin
                   for i:=0 to StrToInt(AudioStreamNb)-1 do
                    begin
                         ListItem := ExtractListView.Items.Add;
                         ListItem.SubItems.Add(WideExtractFilePath(FileName));
                         ListItem.SubItems.Add(WideExtractFileName(FileName));
                         ListItem.SubItems.Add('audio'); // Index or StreamID or StreamType
                         ListItem.SubItems.Add(MediaInfo_Get(Handle, 2, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'PlayTime/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'BitRate/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 2, i, 'Channel(s)', 1, 0)+' Ch - '+
                                                 MediaInfo_Get(Handle, 2, i, 'SamplingRate/String', 1, 0)); // Description
                         ListItem.SubItems.Add('audio'); // Type
                    end;
              end;
       end;

     if SubStreamNb <> '0' then
       begin
            if Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4' then
              begin
                   for i:=0 to StrToInt(SubStreamNb)-1 do
                      begin
                           ListItem := ExtractListView.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 3, i, 'Codec/String', 1, 0)+' - '+
                                                 MediaInfo_Get(Handle, 3, i, 'Codec/Info', 1, 0)); // Description
                           if MediaInfo_Get(Handle, 3, i, 'Codec/String', 1, 0) = 'VobSub' then
                                  ListItem.SubItems.Add('vobsub')
                           else ListItem.SubItems.Add('sub'); // Type
                      end;
              end;
       end;

     if ChapStreamNb <> '0' then
       begin
            if Tnt_WideLowerCase(WideExtractFileExt(FileName)) = '.mp4' then
              begin
                   for i:=0 to StrToInt(ChapStreamNb)-1 do
                      begin
                           ListItem := ExtractListView.Items.Add;
                           ListItem.SubItems.Add(WideExtractFilePath(FileName));
                           ListItem.SubItems.Add(WideExtractFileName(FileName));
                           ListItem.SubItems.Add(MediaInfo_Get(Handle, 4, i, 'ID', 1, 0)); // Index or StreamID or StreamType
                           ListItem.SubItems.Add('Chapters Metadata'); // Description
                           ListItem.SubItems.Add('chap'); // Type
                           Memo1.Lines.Add(MediaInfo_Get(Handle, 4, i, 'Inform', 1, 0));                           
                      end;
              end;
       end;
     MediaInfo_Close(Handle);

     for j:=0 to ExtractListView.Items.Count-1 do
        begin
             ListItem := ExtractListView.Items.Item[j];
             ListItem.Caption := IntToStr(j+1);
        end;
end;

procedure TMainForm.ViewExtractOptions;
var Handle : Cardinal;

begin
     gbExtractOptions.Visible := True;
     rbRaw.Checked := True;

     if (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mp4') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.m4a') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.m4b') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mov') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.3gp') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.3g2') then
       begin
            if ExtractListView.Selected.SubItems[4] = 'video' then
              begin
                   rbRaw.Caption := ExtractToRAW;
                   rbMP4.Caption := ExtractToMP4;
                   rbAVI.Caption := ExtractToAVI;
                   Handle := MediaInfo_New();
                   MediaInfo_Open(Handle,PWideChar(edExtractInput.Text));
                   if MediaInfo_Get(Handle, 1, 0, 'Codec/String', 1, 0) = 'H.264' then
                       rbAVI.Visible := False
                   else  // Extract to AVI only for ASP Streams
                       rbAVI.Visible := True;
                   MediaInfo_Close(Handle);
              end
            else if ExtractListView.Selected.SubItems[4] = 'audio' then
              begin
                   rbRaw.Caption := ExtractToRAW;
                   rbMP4.Caption := ExtractToMP4;
                   rbAVI.Visible := False;
              end
            else if ExtractListView.Selected.SubItems[4] = 'vobsub' then
              begin
                   rbRaw.Caption := ExtractToRAW;
                   rbMP4.Caption := ExtractToMP4;
                   rbAVI.Visible := False;
              end
            else if ExtractListView.Selected.SubItems[4] = 'sub' then
              begin
                   rbRaw.Caption := ExtractToSRT;
                   rbMP4.Caption := ExtractToTTXT;
                   rbAVI.Visible := False;
              end
            else
              begin
                   rbRaw.Caption := ExtractToOGM;
                   rbMP4.Caption := ExtractToCUE;
                   rbAVI.Visible := False;
              end
       end
     else if (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.avi') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mpeg') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mpg') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.vcd') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.vob') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.ts') then
       begin
            if ExtractListView.Selected.SubItems[4] = 'video' then
              begin
                   rbRaw.Caption := ExtractVideoStream;
                   rbMP4.Visible := False; rbAVI.Visible := False;
              end
            else if ExtractListView.Selected.SubItems[4] = 'audio' then
              begin
                   rbRaw.Caption := ExtractAudioStream;
                   rbMP4.Visible := False; rbAVI.Visible := False;
                   Handle := MediaInfo_New();
                   MediaInfo_Open(Handle,PWideChar(edExtractInput.Text));
                   if MediaInfo_Get(Handle, 2, 0, 'Codec/String', 1, 0) = 'AC3' then
                       rbMP4.Visible := False
                   else  // Extract to AVI only for ASP Streams
                       rbMP4.Visible := True;
                   MediaInfo_Close(Handle);
              end;
       end
     else
       begin
            if ExtractListView.Selected.SubItems[4] = 'video' then
              begin
                   rbRaw.Caption := ExtractToRAW;
                   rbMP4.Caption := ExtractToMP4;
                   rbAVI.Visible := False;
              end
            else if ExtractListView.Selected.SubItems[4] = 'audio' then
              begin
                   rbRaw.Caption := ExtractToRAW;
                   rbMP4.Caption := ExtractToMP4;
                   rbAVI.Visible := False;
              end;
       end;
end;

procedure TMainForm.ExtractListViewClick(Sender: TObject);
begin
     if edExtractInput.Text <> '' then
       begin
            ViewExtractOptions;
            ExtractPage.EnableButton(bkNext, True);
       end;
end;

procedure TMainForm.ExtractPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
       begin
            if Muxer then Muxer := False; job_id := 0; Beging_Time := Now; Timer1.Enabled := True;
            if Splitter then Splitter := False;
            if Joiner then Joiner := False;
            if AVIConverter then AVIConverter := False;
            if Tagger then Tagger := False;
            Extracter := True;
            if Converter then Converter := False; ExtracterCmd;
            Wizard.ActivePage := ProcessPage;
            Stop := True;
            if job_id = 0 then
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : File Saved in '+WideExtractFilePath(edExtractInput.Text));
       end
     else begin
              MP4BoxMissingMsg(AdvTaskDialog);
              if AdvTaskDialog.Execute = 100 then
          //  if WideMessageDlg({Msg41+#13#10+Msg42}Msg4, mtInformation, [mbOk], 0) = mrOk then
         begin
              Wizard.ActivePage := MuxPage;
              Stop := True;
         end;
         end;
end;

procedure TMainForm.ExtracterCmd;
begin
     // Disable Back/Finish buttons during the Process
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);
      if btAbort.Enabled = False then btAbort.Enabled := True;

     cmd := '"'+edMP4Box.Text+'"';
     if (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.avi') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mpeg') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mpg') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.vcd') or
        (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.vob') then
       begin
            if ExtractListView.Selected.SubItems[2] = 'video' then
              begin
                   cmd := cmd+' -aviraw video';
                   AddMsg(Format(MsgExtractRawVideo+' %s...', [WideExtractFileName(edExtractInput.Text)]),0);
                  LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractRawVideo+' %s...', [WideExtractFileName(edExtractInput.Text)]));
              end
            else
              begin
                   cmd := cmd+' -aviraw audio';
                   AddMsg(Format(MsgExtractRawAudio+' %s...', [WideExtractFileName(edExtractInput.Text)]),0);
                  LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractRawAudio+' %s...', [WideExtractFileName(edExtractInput.Text)]));
              end;
       end
     else if (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mp4') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.m4a') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.m4b') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.mov') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.3gp') or
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.3g2') or 
             (Tnt_WideLowerCase(WideExtractFileExt(edExtractInput.Text)) = '.ts') then
       begin
            if ExtractListView.Selected.SubItems[4] = 'video' then
              begin
                   if (rbRaw.Checked) or (rbRawAll.Checked) then
                     begin
                          cmd := cmd+' -raw '; // extract to RAW
                          AddMsg(Format(MsgExtractRawVideo+' %s...', [WideExtractFileName(edExtractInput.Text)]),0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractRawVideo+' %s...', [WideExtractFileName(edExtractInput.Text)]));
                     end
                   else if rbMP4.Checked then
                     begin
                          cmd := cmd+' -single ';  // extract to MP4
                          AddMsg(MsgEncapsulateVideoInMP4, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgEncapsulateVideoInMP4);
                     end
                   else if (rbRawAll.Checked) and (rbAVI.Visible) then
                     begin
                          cmd := cmd+' -avi ';  // extract to AVI
                          AddMsg(MsgEncapsulateVideoInAVI, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgEncapsulateVideoInAVI);
                     end
                   else
                     begin
                          cmd := cmd+' -avi ';  // extract to AVI
                          AddMsg(MsgEncapsulateVideoInAVI, 0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgEncapsulateVideoInAVI);
                     end;
                   cmd := cmd+ExtractListView.Selected.SubItems[2];
              end
            else if ExtractListView.Selected.SubItems[4] = 'audio' then
              begin
                   if (rbRaw.Checked) or (rbRawAll.Checked) then cmd := cmd+' -raw '
                   else cmd := cmd+' -single ';
                   cmd := cmd+ExtractListView.Selected.SubItems[2];
                   AddMsg(Format(MsgExtractRawAudio+' %s...', [WideExtractFileName(edExtractInput.Text)]),0);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractRawAudio+' %s...', [WideExtractFileName(edExtractInput.Text)]));
              end
            else if ExtractListView.Selected.SubItems[4] = 'vobsub' then
              begin
                   if (rbRaw.Checked) or (rbRawAll.Checked) then cmd := cmd+' -raw '
                   else cmd := cmd+' -single ';
                   cmd := cmd+ExtractListView.Selected.SubItems[2];
                   AddMsg(Format(MsgExtractVobSub+' %s...', [WideExtractFileName(edExtractInput.Text)]),0);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractVobSub+' %s...', [WideExtractFileName(edExtractInput.Text)]));
              end
            else if ExtractListView.Selected.SubItems[4] = 'sub' then
              begin
                   if (rbRaw.Checked) then
                     begin
                          cmd := cmd+' -srt ';
                          cmd := cmd+ExtractListView.Selected.SubItems[2];
                          AddMsg(Format(MsgExtractSubtitle+' %s '+MsgToSRTFormat, [WideExtractFileName(edExtractInput.Text)]),0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractSubtitle+' %s '+MsgToSRTFormat, [WideExtractFileName(edExtractInput.Text)]));
                     end
                   else
                     begin
                          cmd := cmd+' -ttxt ';
                          cmd := cmd+ExtractListView.Selected.SubItems[2];
                          AddMsg(Format(MsgExtractSubtitle+' %s '+MsgToTTXTFormat, [WideExtractFileName(edExtractInput.Text)]),0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractSubtitle+' %s '+MsgToTTXTFormat, [WideExtractFileName(edExtractInput.Text)]));
                     end;
              end
            else if ExtractListView.Selected.SubItems[4] = 'chap' then
              begin
                   if (rbRaw.Checked) or (rbRawAll.Checked) then
                     begin
                          OGMChap(WideChangeFileExt(edExtractInput.Text, '_chap.txt'));
                          AddMsg(Format(MsgExtractChapters+' %s '+MsgToOGMTextFormat, [WideExtractFileName(edExtractInput.Text)]),0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractChapters+' %s '+MsgToOGMTextFormat, [WideExtractFileName(edExtractInput.Text)]));
                     end
                   else
                     begin
                          CueChap(edExtractInput.Text);
                          AddMsg(Format(MsgExtractChapters+' %s '+MsgToCueSheetFormat, [WideExtractFileName(edExtractInput.Text)]),0);
                          LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgExtractChapters+' %s '+MsgToCueSheetFormat, [WideExtractFileName(edExtractInput.Text)]));
                     end;
              end;
       end;

     { Verbose Mode }
     if chVerbose.Checked then
       begin
            cmd := cmd+' -v';
            VerboseMode := True;
       end
     else cmd := cmd;

     cmd := cmd+' "'+edExtractInput.Text+'"';
     DosCommand.CommandLine := cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(MsgCmdUsedForExtraction+' : %s', [cmd]));
     DosCommand.Execute;
     PriorityCommand;
     if job_id > 0 then LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+MsgFileSavedIn+WideExtractFilePath(edExtractInput.Text));
end;

procedure TMainForm.OGMChap(FileName: WideString);
var i : Integer;
    ChapFile : TStringList;
begin
     ChapFile := TStringList.Create;
     for i:=0 to Memo1.Lines.Count-2 do
        begin
             if i > 8 then
               begin
                    ChapFile.Add('CHAPTER'+IntToStr(i+1)+'='+lefty(' -',right(': ', Memo1.Lines.Strings[i])));
                    ChapFile.Add('CHAPTER'+IntToStr(i+1)+'NAME='+right('- ',Memo1.Lines.Strings[i]));
               end
             else
               begin
                    ChapFile.Add('CHAPTER0'+IntToStr(i+1)+'='+lefty(' -',right(': ', Memo1.Lines.Strings[i])));
                    ChapFile.Add('CHAPTER0'+IntToStr(i+1)+'NAME='+right('- ',Memo1.Lines.Strings[i]));
               end;
        end;
     ChapFile.SaveToFile(FileName);
end;

procedure TMainForm.CueChap(FileName: WideString);
var i: Integer;
    CueFile : TStringList;
begin
     CueFile := TStringList.Create;
     CueFile.Add('PERFORMER " "');
     CueFile.Add('TITLE "'+WideChangeFileExt(WideExtractFileName(FileName), '')+'"');
     CueFile.Add('  FILE "'+WideExtractFileName(FileName)+'" '+Tnt_WideUpperCase(WideExtractFileExt(FileName)));

     for i:=0 to Memo1.Lines.Count-2 do
        begin
             if i > 8 then CueFile.Add('     TRACK '+IntToStr(i+1)+' AUDIO')
             else CueFile.Add('     TRACK 0'+IntToStr(i+1)+' AUDIO');
             CueFile.Add('       TITLE "'+right('- ',Memo1.Lines.Strings[i])+'"');
             CueFile.Add('       PERFORMER " "');
             CueFile.Add('       INDEX 01 '+lefty(' -',right(': ', Memo1.Lines.Strings[i])));
        end;
     CueFile.SaveToFile(WideChangeFileExt(FileName, '.cue'));
end;


procedure TMainForm.scFileDropDrop(Sender: TObject; X, Y: Integer);
var i : Integer;
begin
     for i:=0 to scFileDrop.FileCount-1 do
        begin
              if Wizard.ActivePage = MuxPage then
              begin
                   if (mp4file) then
                     begin
                          if CheckMP4FileExt(scFileDrop.Files[i]) then
                            begin
                                 StreamsInfo(scFileDrop.Files[i]);
                                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(scFileDrop.Files[i])]));
                                 if edMP4Output.Text = '' then edMP4Output.Text := WideChangeFileExt(scFileDrop.Files[i], '.mp4')
                                 else edMP4Output.Text := edMP4Output.Text;
                                 btDelete.Visible := True; btMoveUp.Visible := True;
                                 btMoveDown.Visible := True; btProperties.Visible := True;
                                 { Check whether or not the Items are checked }
                                 if CheckListBoxItems(MP4ListView) then MuxPage.EnableButton(bkNext, True)
                                 else MuxPage.EnableButton(bkNext, False);
                            end;
                     end
                   else  // 3GPP
                     begin
                          if Check3GPPFileExt(scFileDrop.Files[i]) then
                            begin
                                 StreamsInfo(scFileDrop.Files[i]);
                                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(scFileDrop.Files[i])]));
                                 if edMP4Output.Text = '' then edMP4Output.Text := WideChangeFileExt(scFileDrop.Files[i], '.3gp')
                                 else edMP4Output.Text := edMP4Output.Text;
                                 btDelete.Visible := True; btMoveUp.Visible := True;
                                 btMoveDown.Visible := True; btProperties.Visible := True;
                                 { Check whether or not the Items are checked }
                                 if CheckListBoxItems(MP4ListView) then MuxPage.EnableButton(bkNext, True)
                                 else MuxPage.EnableButton(bkNext, False);
                            end;
                     end;
                   if MP4ListView.Items.Count > 0 then SaveInfosas1.Enabled := True
                   else SaveInfosas1.Enabled := False;
              end
              else if (Wizard.ActivePage = ConcatPage) then
                  begin
                       if CheckCatFileExt(scFileDrop.Files[i]) then
                            begin
                                 StreamsInfo(scFileDrop.Files[i]);
                                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(scFileDrop.Files[i])]));
                                 if edConcOutput.Text = '' then edConcOutput.Text := WideChangeFileExt(scFileDrop.Files[i], '.mp4')
                                 else edConcOutput.Text := edConcOutput.Text;
                                 btConcRemove.Visible := True; btConcMoveUp.Visible := True;
                                 btConcMoveDown.Visible := True; btConcProp.Visible := True;
                                 { Check whether or not the Items are checked }
                                 if CheckListBoxItems(ConcListView) then ConcatPage.EnableButton(bkNext, True)
                                 else ConcatPage.EnableButton(bkNext, False);
                            end;
                  end
              else scFileDrop.EnableDrop := False;
        end;
end;

//Initialization
 // DecimalSeparator:='.';

function TMainForm.CalcVal(ed: WideString): Integer;
begin
     if length(ed) < 3 then Result := StrToInt(Copy(ed,0,2))*3600
     else if (length(ed) > 4) and (length(ed) < 6) then
             Result := StrToInt(Copy(ed,0,2))*3600+StrToInt(Copy(ed,4,2))*60
     else if length(ed) > 9 then
             Result := StrToInt(Copy(ed,0,2))*3600+StrToInt(Copy(ed,4,2))*60+StrToInt(Copy(ed,7,2))
     else Result := StrToInt(ed);
end;

procedure TMainForm.cbLangChange(Sender: TObject);
begin
   {  if FindFirst(WideExtractFilePath(Application.ExeName)+'lang\'+'*.ini',faAnyFile,SearchRec) = 0 then
       begin
            repeat
            if (SearchRec.Name <> 'Franais.ini') and (SearchRec.Name <> 'English.ini') then
                  cbLang.Items.Add(WideChangeFileExt(SearchRec.Name, ''));
            until  FindNext(SearchRec) <> 0;
       end;
     FindClose(SearchRec);  }

     case cbLang.ItemIndex of
         0 : LoadIniStrings(WideExtractFilePath(Application.ExeName)+'lang\Castellano.ini');
         1 : LoadIniStrings(WideExtractFilePath(Application.ExeName)+'lang\English.ini');
         2 : LoadIniStrings(WideExtractFilePath(Application.ExeName)+'lang\Franais.ini');
     else LoadIniStrings(WideExtractFilePath(Application.ExeName)+'lang\'+cbLang.Text+'.ini');
     end;
end;

procedure TMainForm.CreationListDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var S : string;
    Text : string;
    t : Integer;
begin
     t := Length(CreationList.Items[Index]) - 1;
     S := AnsiLeftStr(CreationList.Items[Index], 1);
     Text := AnsiRightStr(CreationList.Items[Index], t);
  //
  CreationList.Canvas.Font.Style := [fsBold];
  CreationList.Canvas.TextOut(0, Rect.Top, S);
  CreationList.Canvas.Font.Style := [];
  CreationList.Canvas.TextOut(8, Rect.Top, Text);
end;

procedure TMainForm.MP4ListViewColumnClick(Sender: TObject;
  Column: TListColumn);
begin
//     InfoPopUpMenu.AutoPopup := False;
     ColumnToSort := Column.Index;
     (Sender as TCustomListView).AlphaSort;
end;

procedure TMainForm.MP4ListViewCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
var
  ix: Integer;
begin
  if ColumnToSort = 0 then
    Compare := CompareText(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompareText(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;


procedure TMainForm.PlaybtClick(Sender: TObject);
begin
     chVideoPreviewClick(Sender);
end;


procedure TMainForm.Timer2Timer(Sender: TObject);
var elapsed, estimated: double;
begin
     VideoTrackBar.Position := MilliSecondsBetween(Now, Beging_Time2);
     edSplitDuration.Text := FormatDateTime('hh:nn:ss.zzz',Now-Beging_Time2);

     elapsed := MilliSecondSpan(Now,Beging_Time2);
     if VideoTrackBar.Position = 0 then estimated := 0
     else estimated := (elapsed*(VideoTrackBar.Max-VideoTrackBar.Position))/VideoTrackBar.Position;
end;

procedure TMainForm.SettingsListDblClick(Sender: TObject);
begin
     Wizard.ActivePage := SettingsPage;
end;

procedure TMainForm.FilesTagListSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
      if FilesTagList.Selected <> nil then
               begin
                    edName.Text := GetTitle(Item.SubItems[0]+Item.SubItems[1]);
                    edArtist.Text := GetArtist(Item.SubItems[0]+Item.SubItems[1]);
                    edAlbum.Text := GetAlbum(Item.SubItems[0]+Item.SubItems[1]);
                    edYear.Text := GetYear(Item.SubItems[0]+Item.SubItems[1]);
                    edDuration.Text := GetDuration(Item.SubItems[0]+Item.SubItems[1]);
               end;
end;

procedure TMainForm.TagPageBackButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Wizard.ActivePage := Page1;
     Stop := True;
end;

procedure TMainForm.FilesTagListCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
const
  cStripe = $FAE6D8;  // colour of alternate list items
begin
     if chiTunesStyle.Checked then
       begin
  if Odd(Item.Index) then
    // odd list items have green background
    FilesTagList.Canvas.Brush.Color := cStripe
  else
    // even list items have window colour background
    FilesTagList.Canvas.Brush.Color := clWindow;
       end;
end;

procedure TMainForm.MP4ListViewColumnRightClick(Sender: TObject;
  Column: TListColumn; Point: TPoint);
begin
//     if MP4ListView.Selected <> nil then InfoPopUpMenu.AutoPopup := True
  //   else begin
     GetCursorPos(Point);
     PopupMenu1.Popup(Point.x, Point.y);
     if InfoPopupMenu.AutoPopup then InfoPopUpMenu.AutoPopup := False;
end;

procedure TMainForm.FilesTagListColumnRightClick(Sender: TObject;
  Column: TListColumn; Point: TPoint);
begin
     GetCursorPos(Point);
     TagPopupMenu.Popup(Point.x, Point.y);
end;

procedure TMainForm.FilesTagListPopUpMenuClick(Sender: TObject);
begin
     with Sender as TTntMenuItem do
     case Tag of
          0 : begin
                   Name2.Checked := not Name2.Checked;
                   if Name2.Checked then FilesTagList.Columns[3].Width := 200 else
                      FilesTagList.Columns[3].Width := 0;
              end;
          1 : begin
                   Timing.Checked := not Timing.Checked;
                   if Timing.Checked then FilesTagList.Columns[4].Width := 80 else
                      FilesTagList.Columns[4].Width := 0;
              end;
          2 : begin
                   Artist1.Checked := not Artist1.Checked;
                   if Artist1.Checked then FilesTagList.Columns[5].Width := 50 else
                      FilesTagList.Columns[5].Width := 0;
              end;
          3 : begin
                   Album1.Checked := not Album1.Checked;
                   if Album1.Checked then FilesTagList.Columns[6].Width := 50 else
                      FilesTagList.Columns[6].Width := 0;
              end;
          4 : begin
                   Year1.Checked := not Year1.Checked;
                   if Year1.Checked then FilesTagList.Columns[7].Width := 50 else
                      FilesTagList.Columns[7].Width := 0;
              end;
          5 : begin
                   Genre1.Checked := not Genre1.Checked;
                   if Genre1.Checked then FilesTagList.Columns[8].Width := 50 else
                      FilesTagList.Columns[8].Width := 0;
              end;

     end;
end;

procedure TMainForm.MP4ListViewMenuClick(Sender: TObject);
var ListV: TTntListView;
begin
     if Wizard.ActivePage = MuxPage then ListV := MP4ListView
     else ListV := ConcListView;
     with Sender as TTntMenuItem do
     case Tag of
          0 : begin
                   Index1.Checked := not Index1.Checked;
                   if Index1.Checked then ListV.Columns[2].Width := 224 else
                      ListV.Columns[2].Width := 0;
              end;
          1 : begin
                   Indexation.Checked := not Indexation.Checked;
                   if Indexation.Checked then ListV.Columns[3].Width := 60 else
                      ListV.Columns[3].Width := 0;
              end;
          2 : begin
                   Description1.Checked := not Description1.Checked;
                   if Description1.Checked then ListV.Columns[4].Width := 300 else
                      ListV.Columns[4].Width := 0;
              end;
          3 : begin
                   Name1.Checked := not Name1.Checked;
                   if Name1.Checked then ListV.Columns[5].Width := 150 else
                      ListV.Columns[5].Width := 0;
              end;
          4 : begin
                   Language1.Checked := not Language1.Checked;
                   if Language1.Checked then ListV.Columns[6].Width := 100 else
                      ListV.Columns[6].Width := 0;
              end;
          5 : begin
                   FPS.Checked := not FPS.Checked;
                   if FPS.Checked then ListV.Columns[7].Width := 100 else
                      ListV.Columns[7].Width := 0;
              end;
          6 : begin
                   ype1.Checked := not ype1.Checked;
                   if ype1.Checked then ListV.Columns[8].Width := 60 else
                      ListV.Columns[8].Width := 0;
              end;
          7 : begin
                   BrandName1.Checked := not BrandName1.Checked;
                   if BrandName1.Checked then ListV.Columns[9].Width := 100 else
                      ListV.Columns[9].Width := 0;
              end;
          8 : begin
                   PAR1.Checked := not PAR1.Checked;
                   if PAR1.Checked then ListV.Columns[10].Width := 60 else
                      ListV.Columns[10].Width := 0;
              end;
          9 : begin
                   Delay1.Checked := not Delay1.Checked;
                   if Delay1.Checked then ListV.Columns[13].Width := 60 else
                      ListV.Columns[13].Width := 0;
              end;
     end;
end;


procedure TMainForm.TntImage26Click(Sender: TObject);
begin
     if OpenDirDialog.Execute then
       begin
            if right(':\',OpenDirDialog.Path) = '' then
                 edTemp.Text := OpenDirDialog.Path
            else edTemp.Text := OpenDirDialog.Path+'\';
            LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+
                       Format('%s added as Temp Directory...', [edTemp.Text]));
       end;
end;

procedure TMainForm.rbRawAllClick(Sender: TObject);
begin
     if ExtractListView.ItemIndex <> 0 then ExtractListView.ItemIndex :=0;
     job_t := ExtractListView.Items.Count;
end;

procedure TMainForm.rbRawClick(Sender: TObject);
begin
     if job_t > 1 then job_t := 0;
end;

procedure TMainForm.rbMP4Click(Sender: TObject);
begin
     if job_t > 1 then job_t :=0;
end;

procedure TMainForm.rbAVIClick(Sender: TObject);
begin
     if job_t > 1 then job_t :=0;
end;


procedure TMainForm.ConcListViewClick(Sender: TObject);
begin
     if CheckListBoxItems(ConcListView) then ConcatPage.EnableButton(bkNext, True)
     else ConcatPage.EnableButton(bkNext, False);
end;

// Enable iTunes Style
procedure TMainForm.ConcListViewCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
const
  cStripe = $FAE6D8;  // colour of alternate list items
begin
     if chiTunesStyle.Checked then
       begin
  if Odd(Item.Index) then
    // odd list items have green background
    ConcListView.Canvas.Brush.Color := cStripe
  else
    // even list items have window colour background
    ConcListView.Canvas.Brush.Color := clWindow;
       end;
end;

{
      Concatenation Part
}
procedure TMainForm.btConcAddClick(Sender: TObject);
var i: Integer;
    OPFilter : WideString;
    s, s1 : String;
begin
     OPFilter := 'All Files supported (*.*)|*.avi;*.mp4;*.m4a;*.m4b;*.mov;*.3gp;*.3g2;*.ts;*.mpeg;*.mpg;*.vcd;*.vob;*.qcp;*.ogg;*.m4v;*.cmp;*.m1v;*.m2v;*.263;*.h263;*.264;*.h264;*.smv;*.mp2;*.mp3;*.mpa;*.evc;*.amr;*.awb;*.aac;|'+
                 '--- Audio Files ---|*.aac;*.amr;*.awb;*.evc;*.mp3;*.mp2;*.mpa;*.smv|'+
                 '    AAC Files (*.aac)|*.aac|'+
                 '    AMR Files (*.amr;*.awb)|*.amr;*.awb|'+
                 '    EVRC Files (*.evc)|*.evc|'+
                 '    MPEG-1 Audio Files (*mp3;*.mp2)|*.mp3;*.mp2;*.mpa|'+
                 '    SMV Files (*.smv)|*.smv|'+
                 '--- Video Files ---|*.263;*.h263;*.264;*.h264;*.m1v;*.m2v;*.m4v;*.cmp|'+
                 '    H263 Video Files (*.263;*.h263)|*.263;*.h263|'+
                 '    H264 Video Files (*.264;*.h264)|*.264;*.h264|'+
                 '    MPEG-1/2 Raw Files (*.m1v;*.m2v)|*.m1v;*.m2v|'+
                 '    MPEG-4 Raw Files (*.m4v;*.cmp)|*.m4v;*.cmp|'+
                 '--- Container Files ---|*.avi;*.mpeg;*.mpg;*.vcd;*.vob;*.ts;*.mov;*.ogg;*.qcp;*.3gp;*.3g2|'+
                 '    AVI Files (*.avi)|*.avi|'+
                 '    MPEG-4 Files (*.mp4;*.m4a;*.m4b)|*.mp4;*.m4a;*.m4b|'+
                 '    MPEG-PS Files (*.mpeg;*.mpg;*.vcd;*.vob)|*.mpeg;*.mpg;*.vcd;*.vob|'+
                 '    MPEG-TS Files (*.ts)|*.ts|'+
                 '    MOV Files (*.mov)|*.mov|'+
                 '    OGG Files (*.ogg)|*.ogg|'+
                 '    QCP Files (*.qcp)|*.qcp|'+
                 '    3GPP Files (*.3gp;*.3g2)|*.3gp;*.3g2';
     s := '';
     s1 := 'avi';

     if isWindowsVista then
       begin
            if OpenSaveFileDialog(Handle, s1, OPFilter, ' ', 'Select your File', s, True, True, False, True, False) then
              begin
                   StreamsInfo(s);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(s)]));
                   if edConcOutput.Text = '' then edConcOutput.Text := WideChangeFileExt(s, '.mp4')
                   else edConcOutput.Text := edConcOutput.Text;
              end;
       end
     else
       begin
            OpenDialog.Filter := OPFilter;
            OpenDialog.FilterIndex := 1;
            OpenDialog.Options := [ofAllowMultiSelect];
            if OpenDialog.Execute then
              begin
                   for i:=0 to OpenDialog.Files.Count-1 do
                      begin
                           StreamsInfo(OpenDialog.Files.Strings[i]);
                           LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+Floaded, [WideExtractFileName(OpenDialog.Files.Strings[i])]));
                           if edConcOutput.Text = '' then edConcOutput.Text := WideChangeFileExt(OpenDialog.Files.Strings[0], '.mp4')
                           else edConcOutput.Text := edConcOutput.Text;
                      end;
              end;
       end;

       btConcRemove.Visible := True; btConcMoveUp.Visible := True;
       btConcMoveDown.Visible := True; btConcProp.Visible := True;

       { Check whether or not the Items are checked }
       if CheckListBoxItems(ConcListView) then ConcatPage.EnableButton(bkNext, True)
       else ConcatPage.EnableButton(bkNext, False);
end;

procedure TMainForm.btConcRemoveClick(Sender: TObject);
var Item_List: TListItem;
begin
     if ConcListView.ItemIndex > -1 then
       begin
           if WideMessageDlg(Msg1, mtWarning, [mbOk, mbCancel], 0) = mrOk then
          begin
               Item_List := ConcListView.Selected;
               if Item_List <> nil then Item_List.Delete;
          end;
       end;
end;

procedure TMainForm.btConcMoveUpClick(Sender: TObject);
begin
     if ConcListView.Selected <> nil then
       ExchangeItems(ConcListView,ConcListView.Selected.Index,ConcListView.Selected.Index-1);
end;

procedure TMainForm.btConcMoveDownClick(Sender: TObject);
begin
     if ConcListView.Selected <> nil then
       ExchangeItems(ConcListView,ConcListView.Selected.Index+1,ConcListView.Selected.Index);
end;

procedure TMainForm.btConcPropClick(Sender: TObject);
begin
     if ConcListView.Selected <> nil then
       begin
            ReadInfo;
            PropForm.ShowModal;
       end;
end;

procedure TMainForm.cbOutputFormatChange(Sender: TObject);
begin
     if edConcOutput.Text <> '' then
     case cbOutputFormat.ItemIndex of
         0 : begin
                  edConcOutput.Text := WideChangeFileExt(edConcOutput.Text, '.mp4');
                  cbCompliance2.Enabled := True;
             end;
         1 : begin
                  edConcOutput.Text := WideChangeFileExt(edConcOutput.Text, '.3gp');
                  cbCompliance2.Enabled := False;
             end; 
     end;  
end;

procedure TMainForm.ConcListViewColumnRightClick(Sender: TObject;
  Column: TListColumn; Point: TPoint);
begin
     GetCursorPos(Point);
     PopupMenu1.Popup(Point.x, Point.y);
end;

procedure TMainForm.btConcBrowseClick(Sender: TObject);
begin
     SaveDialog.Filter := 'MP4 Files (*.mp4)|*.mp4|'+
                          '3GPP Files (*.3gp)|*.3gp';
     if cbOutputFormat.ItemIndex = 1 then SaveDialog.FilterIndex := 1
     else SaveDialog.FilterIndex := 2;
     if edConcOutput.Text <> '' then SaveDialog.FileName := WideExtractFileName(edConcOutput.Text);
     if SaveDialog.Execute then
       begin
             if cbOutputFormat.ItemIndex = 1 then
                  edConcOutput.Text := WideChangeFileExt(SaveDialog.FileName, '.mp4')
            else  edConcOutput.Text := WideChangeFileExt(SaveDialog.FileName, '.3gp');
       end;
end;

procedure TMainForm.JoinCmd;
var i: Integer;
    ListItem : TTntListItem;
begin
      { Disable Back/Finish buttons during the Process }
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);
       if btAbort.Enabled = False then btAbort.Enabled := True;

     { M4Box executable }
     cmd := '"'+edMP4Box.Text+'"';

     { ISMA & iPod & PSP compliances }
     if cbCompliance2.Enabled then
     case cbCompliance2.ItemIndex of
         0 : cmd := cmd;
         1 : cmd := cmd+' -ipod';
         2 : cmd := cmd+' -isma';
         3 : cmd := cmd+' -psp';
     end;

     for i:=0 to ConcListView.Items.Count-1 do
        begin
             ListItem := ConcListView.Items.Item[i];
             if ListItem.Checked then
               begin
                    if ListItem.SubItems[8] <> '' then // Brand-Name
                         cmd := cmd+'-brand '+ListItem.SubItems[8]
                    else cmd := cmd;
                    if ListItem.SubItems[13] <> '' then // Interleave
                         cmd := cmd+'-inter '+ListItem.SubItems[13]
                    else cmd := cmd;
                    if ListItem.SubItems[11] <> '' then // Copyright
                         cmd := cmd+'-cprt '+ListItem.SubItems[11]
                    else cmd := cmd;

                    if (ListItem.SubItems[7] <> 'chap') then
                      begin
                           if ListItem.Index = 0 then cmd := cmd+' -add "'
                           else cmd := cmd+' -cat "';
                      end;

                    cmd := cmd+ListItem.SubItems[0]+ListItem.SubItems[1]; // Path & FileName

                    if (ListItem.SubItems[2] = '') and (ListItem.SubItems[7] <> '') then
                         cmd := cmd
                    else if (ListItem.SubItems[7] = 'audio') or
                            (ListItem.SubItems[7] = 'video') or
                            (ListItem.SubItems[7] = 'vobsub') then
                         cmd := cmd+'#'+ListItem.SubItems[2]
                    else cmd := cmd; // Ids

                    if ListItem.SubItems[4] <> '' then // Name
                         cmd := cmd+':name='+ListItem.SubItems[4]
                    else cmd := cmd;
                    if ListItem.SubItems[5] <> '' then // Language
                         cmd := cmd+':lang='+Full2ShortLanguageName(ListItem.SubItems[5])
                    else cmd := cmd;
                    if ListItem.SubItems[6] <> '' then // Frame-Rate
                         cmd := cmd+':fps='+ListItem.SubItems[6]
                    else cmd := cmd;
                    if ListItem.SubItems[9] <> '' then // PAR
                         cmd := cmd+':par='+ListItem.SubItems[9]
                    else cmd := cmd;
                    if ListItem.SubItems[10] = 'sbr' then // HE-AAC Signal
                         cmd := cmd+':sbr'
                    else if ListItem.SubItems[10] = 'sbrx' then
                         cmd := cmd+':sbrx'
                    else cmd := cmd;
                    if ListItem.SubItems[12] <> '' then // Delay
                         cmd := cmd+':delay='+ListItem.SubItems[12]
                    else cmd := cmd;
                    if ListItem.SubItems[15] <> '' then // Font Name
                         cmd := cmd+':font='+ListItem.SubItems[15]
                    else cmd := cmd;
                    if ListItem.SubItems[16] <> '' then // Font Size
                         cmd := cmd+':size='+ListItem.SubItems[16]
                    else cmd := cmd;
                    cmd := cmd+'"';
               end;
        end;

     { Temp dir }
     if edTemp.Text <> '' then cmd := cmd+' -tmp '+edTemp.Text;

     { Verbose Mode }
     if chVerbose.Checked then
       begin
            cmd := cmd+' -v';
            VerboseMode := True;
       end
     else cmd := cmd;

     { Overwrite }
     if chOverWrite.Checked then cmd := cmd+' -new "'+edConcOutput.Text+'"'
     else cmd := cmd+' "'+edConcOutput.Text+'"'; // Output File Name

     { Add Message to Logfile }
     AddMsg(Format(Msg5+' %s...', [WideExtractFileName(edConcOutput.Text)]),0);
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg5+' %s...', [WideExtractFileName(edConcOutput.Text)]));
     DosCommand.CommandLine := cmd;
     LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg6+' : %s', [cmd]));

     { Execute command line & Priorities }
     DosCommand.Execute;
     PriorityCommand;
end;

procedure TMainForm.ConcatPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
       begin
            if WideFileExists(edConcOutput.Text) then
              begin
                   if (rawAVC) and (PropForm.edFrameRate.Text = '') then
                     begin
                          MsgrawAVC(AdvTaskDialog);
                          if AdvTaskDialog.Execute = 100 then
                            begin
                                 btProperties.OnClick(Sender);
                            end;
                     end
                   else
                     begin
                          OverwriteMsg(AdvTaskDialog, edConcOutput.Text);
                          if AdvTaskDialog.Execute = 100 then
                   // if WideMessageDlg(Format(MsgOverwriteOrNot+' %s ?',[WideExtractFileName(edConcOutput.Text)]),mtInformation, [mbYes, mbNo],0) = mrYes then
                            begin
                                 chOverWrite.Checked := True;
                                 LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format('%s '+MsgOverwritten,[WideExtractFileName(edMP4Output.Text)]));
                                Wizard.ActivePage := ProcessPage; job_id := 0; Beging_Time := Now;
                                Timer1.Enabled := True; Stop := True;
                                if Muxer then Muxer := False;
                                if Tagger then Tagger := False;
                                if Splitter then Splitter := False;
                                Joiner := True;
                                if AVIConverter then AVIConverter := False;
                               JoinCmd;
                                LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Msg3+' '+WideExtractFilePath(edConcOutput.Text));
                            end
                        else begin
                              Wizard.ActivePage := ConcatPage;
                              Stop := True;
                         end;
                   end;
              end
            else begin
                      if (rawAVC) and (PropForm.edFrameRate.Text = '') then
                        begin
                             MsgrawAVC(AdvTaskDialog);
                             if AdvTaskDialog.Execute = 100 then
                               begin
                                    btProperties.OnClick(Sender);
                               end;
                        end
                      else
                        begin
                             Wizard.ActivePage := ProcessPage; job_id := 0; Beging_Time := Now;
                             Timer1.Enabled := True; Stop := True;
                             if Muxer then Muxer := False;
                             if Tagger then Tagger := False;
                             if Splitter then Splitter := False;
                             Joiner := True;
                             if AVIConverter then AVIConverter := False;
                            JoinCmd;
                             LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Msg3+' '+WideExtractFilePath(edConcOutput.Text));
                        end;
                end;
       end
     else begin
              MP4BoxMissingMsg(AdvTaskDialog);
              if AdvTaskDialog.Execute = 100 then
          //  if WideMessageDlg({Msg41+#13#10+Msg42}Msg4, mtInformation, [mbOk], 0) = mrOk then
         begin
              Wizard.ActivePage := MuxPage;
              Stop := True;
         end;
         end;
end;

procedure TMainForm.TagPageNextButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     if (edMP4Box.Text <> '') and (Tnt_WideLowerCase(WideExtractFileName(edMP4Box.Text)) = 'mp4box.exe') then
       begin
            if Muxer then Muxer := False;  Beging_Time := Now;
            Timer1.Enabled := True;
            job_id := 0; job_t := FilesTagList.Items.Count;
            if Splitter then Splitter := False;
            if Joiner then Joiner := False;
            if AVIConverter then AVIConverter := False;
            if Extracter then Extracter := False;
            if Converter then Converter := False;
            Tagger := True; FilesTagCmd;
            Wizard.ActivePage := ProcessPage;
            Stop := True;
       end
     else begin
              MP4BoxMissingMsg(AdvTaskDialog);
              if AdvTaskDialog.Execute = 100 then
                begin
                     Wizard.ActivePage := MuxPage;
                     Stop := True;
                end;
         end;
end;

// Save Yamb infos as template
procedure TMainForm.YambForm1Click(Sender: TObject);
begin
     InfoSaveDialog.FileName := 'Yamb-infos.txt';
     InfoSaveDialog.Filter := 'Text Files (*.txt)|*.txt';
     if InfoSaveDialog.Execute then
     SaveListviewStrings(MP4ListView, InfoSaveDialog.FileName);
end;


procedure TMainForm.Button1Click(Sender: TObject);
begin
     MsgNotCompatible(AdvTaskDialog,0);
end;

procedure TMainForm.AddFileTotheList(AudioFile: WideString; FileExtension: WideString);
var
  FileS: TFileStream;
  FSize: Cardinal;
begin
     FileS := TFileStream.Create(AudioFile, fmOpenRead or fmShareDenyNone);
     FSize := FileS.Size;
     FileS.Free;
     if FSize > 0 then
            if FileExtension = '.mp4' then AddFileForShellTV(AudioFile)
       else if FileExtension = '.m4a' then AddFileForShellTV(AudioFile);
end;

// Popup Menu in Process Page
procedure TMainForm.ViewLogFile1Click(Sender: TObject);
begin
     if chYambLog.Checked then
       begin
            LogFileExists(Application.ExeName);
            LogMsg.SaveToFile(WideExtractFilePath(Application.ExeName)+'Yamb.log');
       end
     else if chOutputLog.Checked then
         begin
              if Converter then
                begin
                     LogFileExists(edConvInput.Text);
                     LogMsg.SaveToFile(WideExtractFilePath(edConvInput.Text)+'Yamb.log');
                end
              else if Extracter then
                begin
                     LogFileExists(edExtractInput.Text);
                     LogMsg.SaveToFile(WideExtractFilePath(edExtractInput.Text)+'Yamb.log');
                end
              else if Muxer then
                begin
                     LogFileExists(edMP4Output.Text);
                     LogMsg.SaveToFile(WideExtractFilePath(edMP4Output.Text)+'Yamb.log');
                end
              else if Joiner then
                begin
                     LogFileExists(edConcOutput.Text);
                     LogMsg.SaveToFile(WideExtractFilePath(edConcOutput.Text)+'Yamb.log');
                end
              else if Splitter then
                begin
                     LogFileExists(edSplitInput.Text);
                     LogMsg.SaveToFile(WideExtractFilePath(edSplitInput.Text)+'Yamb.log');
                end
              else if Tagger then
                begin
                      LogFileExists(FilesTagList.Selected.SubItems[0]+FilesTagList.Selected.SubItems[1]);
                      LogMsg.SaveToFile(FilesTagList.Selected.SubItems[0]+'Yamb.log');
                end
         end;

     if OpenDialog.FileName <> '' then OpenDialog.FileName := '';
     OpenDialog.Filter := 'Log Files (*.log)|*.log';
     if OpenDialog.Execute then
       begin
            Tnt_ShellExecuteW(0, 'OPEN', 'notepad.exe', PWideChar(OpenDialog.FileName), nil, SW_SHOW);
       end;
end;

procedure TMainForm.Full1Click(Sender: TObject);
begin
      SaveInfos := True; Memo2.Lines.Clear;
     if MP4ListView.Selected <> nil then
       begin
     DosCommand.CommandLine := '"'+edMP4Box.Text+'" -info "'+MP4ListView.Selected.SubItems[0]+
                                  MP4ListView.Selected.SubItems[1]+'"';
     DosCommand.Execute;
     InfoSaveDialog.Filter := 'Text Files (*.txt)|*.txt';
     InfoSaveDialog.FileName := 'MP4Box-infos.txt';
     if InfoSaveDialog.Execute then
       Memo2.Lines.SaveToFile(InfoSaveDialog.FileName);
       end;
end;

procedure TMainForm.ByTrack1Click(Sender: TObject);
begin
      SaveInfos := True; Memo2.Lines.Clear;
     if MP4ListView.Selected <> nil then
       begin
            if (MP4ListView.Selected.SubItems[2] = 'video') or
               (MP4ListView.Selected.SubItems[2] = 'audio') or
               (MP4ListView.Selected.SubItems[2] = 'sub') or
               (MP4ListView.Selected.SubItems[2] = '') then
                DosCommand.CommandLine := '"'+edMP4Box.Text+'" -info "'+MP4ListView.Selected.SubItems[0]+
                                          MP4ListView.Selected.SubItems[1]+'"'
            else DosCommand.CommandLine := '"'+edMP4Box.Text+'" -info '+MP4ListView.Selected.SubItems[2]+' "'+
                                          MP4ListView.Selected.SubItems[0]+
                                          MP4ListView.Selected.SubItems[1]+'"';
     DosCommand.Execute;
     InfoSaveDialog.Filter := 'Text Files (*.txt)|*.txt';
     InfoSaveDialog.FileName := 'MP4Box-infos.txt';
     if InfoSaveDialog.Execute then
       Memo2.Lines.SaveToFile(InfoSaveDialog.FileName);
       end;
end;

procedure TMainForm.LsDirTree211DirChange(Sender: TObject;
  SelectedPath: String);
var SearchRec : TSearchRec;

begin
      FilesTagList.Items.Clear; FilesTagPath := SelectedPath;
     if (FindFirst(SelectedPath+'\*.'+Tnt_WideLowerCase('m4a'),faAnyFile,SearchRec) = 0) then
      repeat
            begin
                 Cursor := (crHourGlass);
                 AddFileForShellTV(SearchRec.Name);
            end
      until  FindNext(SearchRec) <> 0;
     Cursor := crDefault;

     if (FindFirst(SelectedPath+'\*.'+Tnt_WideLowerCase('mp4'),faAnyFile,SearchRec) = 0) then
      repeat
            begin
                 Cursor := crHourGlass;
                 AddFileForShellTV(SearchRec.Name);
            end
      until  FindNext(SearchRec) <> 0;
     Cursor := crDefault;
     FindClose(SearchRec);
     
     { Check whether or not the Items are checked }
       if CheckListBoxItems(FilesTagList) then TagPage.EnableButton(bkNext, True)
       else TagPage.EnableButton(bkNext, False);
end;

procedure TMainForm.MoreClick(Sender: TObject);
begin
      gbInput.Height := gbInput.Height - 30;
      gbMP4Output.Top := gbInput.Height + 85;
      gbMP4Output.Height := gbMP4Output.Height + 25;
      cbSplitOut.Visible := True; chHint.Visible := True;
      cbCompliance.Visible := True; chVFR.Visible := True;
      lbCompliance.Visible := True; lbSplitat.Visible := True;
      Less.Visible := True; More.Visible := False;
end;

procedure TMainForm.LessClick(Sender: TObject);
begin
     gbInput.Height := gbInput.Height + 30;
     gbMP4Output.Top := gbMP4Output.Top + 25;
     gbMP4Output.Height := gbMP4Output.Height - 25;
     cbSplitOut.Visible := False; chHint.Visible := False;
     cbCompliance.Visible := False; chVFR.Visible := False;
     lbCompliance.Visible := False; lbSplitat.Visible := False;
     Less.Visible := False; More.Visible := True;
end;

procedure TMainForm.More2Click(Sender: TObject);
begin
     gbConcInput.Height := gbConcInput.Height - 30;
     gbConcOutput.Top := gbConcInput.Height + 90;
     gbConcOutput.Height := gbConcOutput.Height + 25;
     cbOutputFormat.Visible := True; cbCompliance2.Visible := True;
     lbCompliance2.Visible := True; lbConcOutput.Visible := True;
     Less2.Visible := True; More2.Visible := False;
end;

procedure TMainForm.Less2Click(Sender: TObject);
begin
     gbConcInput.Height := gbConcInput.Height + 35;
     gbConcOutput.Top := gbConcOutput.Top + 28;
     gbConcOutput.Height := gbConcOutput.Height - 28;
     cbOutputFormat.Visible := False; cbCompliance2.Visible := False;
     lbCompliance2.Visible := False; lbConcOutput.Visible := False;
     Less2.Visible := False; More2.Visible := True;
end;


procedure TMainForm.DosCommand2NewLine(Sender: TObject; NewLine: String;
  OutputType: TOutputType);
begin
     Parse_AP(NewLine); 
end;

procedure TMainForm.MP4ListViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbRight then InfoPopUpMenu.AutoPopup := True;
end;


procedure TMainForm.dpbt2Click(Sender: TObject);
begin
     if aa <> FilesTagList.Items.Count then
      begin
           if FilesTagList.Items[aa].Checked = False then inc(aa);
           FilesTagList.Items[aa].Selected := true;
           inc(aa);
      end;
end;

procedure TMainForm.spbt1Click(Sender: TObject);
begin
     if FilesTagList.Items[0].Selected = False then
       begin
            dec(aa);
            if FilesTagList.Items[aa-1].Checked = False then dec(aa);
            FilesTagList.Items[aa-1].Selected := true;
       end;
end;

procedure TMainForm.TntStaticText1Click(Sender: TObject);
begin
     if OpenPictureDiag.Execute then
       begin
            TntImage25.Picture.LoadFromFile(OpenPictureDiag.FileName);
            edPic.Text := OpenPictureDiag.FileName;
            TntStaticText1.Visible := False;
       end;
end;

procedure TMainForm.edYearKeyPress(Sender: TObject; var Key: Char);
begin
     if not (Key in ['0'..'9', DecimalSeparator, Chr(VK_BACK), Chr(VK_DELETE)]) then
       Key := #0;
     if Key = DecimalSeparator then
     if Pos(DecimalSeparator, edYear.Text) <> 0 then
      Key := #0;
end;

procedure TMainForm.WriteTags;
begin
     if FilesTagList.Selected <> nil then
       begin
            if edName.Text <> '' then  // Name
              FilesTagList.Selected.SubItems[2] := edName.Text;
            if edArtist.Text <> '' then // Artist
              FilesTagList.Selected.SubItems[4] := edArtist.Text;
            if edAlbum.Text <> '' then // Album
              FilesTagList.Selected.SubItems[5] := edAlbum.Text;
            if edYear.Text <> '' then // Year
              FilesTagList.Selected.SubItems[6] := edYear.Text;
            if (cbGenre.ItemIndex <> 0) or (cbGenre.ItemIndex <> 20) then // Genre
              FilesTagList.Selected.SubItems[7] := cbGenre.Text; 
       end;
end;

procedure TMainForm.editComponentChange(Sender: TObject);
begin
     WriteTags;
end;

procedure TMainForm.FilesTagCmd;
var i: Integer;
    ListItem : TTntListItem;

begin
     { Disable Back/Finish buttons during the Process }
      ProcessPage.EnableButton(bkFinish, false);
      ProcessPage.EnableButton(bkBack, false);
      if btAbort.Enabled = False then btAbort.Enabled := True;

     { Tagger choice }
     if Tnt_WideLowerCase(WideExtractFileName(edTagger.Text)) = 'mp4box.exe' then
       begin
            cmd := '"'+edTagger.Text+'"';
            if FilesTagList.Selected.Checked then
              begin
                   { tags stuff }
                    cmd := cmd+' -itags ';
                    if tagger then
                      begin
                           if PropForm.edName.Text <> '' then cmd := cmd+SetNameTags(1) else cmd := cmd;
                           if PropForm.edArtist.Text <> '' then cmd := cmd+SetArtistTags(1) else cmd := cmd;
                           if PropForm.edAlbum.Text <> '' then cmd := cmd+SetAlbumTags(1) else cmd := cmd;
                           if PropForm.edYear.Text <> '' then cmd := cmd+SetYearTags(1) else cmd := cmd;
                           if PropForm.cbGenre.Text <> '' then cmd := cmd+SetGenreTags(1) else cmd := cmd;
                           if PropForm.edWriter.Text <> '' then cmd := cmd+SetWriterTags(1) else cmd := cmd;
                           if PropForm.edTrackN1.Text <> '' then cmd := cmd+SetTrackPTags(1) else cmd := cmd;
                           if PropForm.edTrackNum2.Text <> '' then cmd := cmd+SetTrackTTags(1) else cmd := cmd;
                           if PropForm.edDiskNum1.Text <> '' then cmd := cmd+SetDiskPTags(1) else cmd := cmd;
                           if PropForm.edDiskNum2.Text <> '' then cmd := cmd+SetDiskTTags(1) else cmd := cmd;
                           if PropForm.edTempo.Text <> '' then cmd := cmd+SetTempoTags(1) else cmd := cmd;
                           if PropForm.edGroup.Text <> '' then cmd := cmd+SetGroupTags(1) else cmd := cmd;
                           if PropForm.edEncoder.Text <> '' then cmd := cmd+SetEncoderTags(1) else cmd := cmd;
                           if PropForm.MemoComments.Text <> '' then cmd := cmd+SetCommentsTags(1) else cmd := cmd;
                           if PropForm.edTool.Text <> '' then cmd := cmd+SetToolTags(1) else cmd := cmd;
                           if PropForm.ThumbView.SelectedFile <> '' then cmd := cmd+SetPictureTags(1) else cmd := cmd;
                      end
                    else
                      begin
                           if edName.Text <> '' then cmd := cmd+SetNameTags(0) else cmd := cmd;
                           if edArtist.Text <> '' then cmd := cmd+SetArtistTags(0) else cmd := cmd;
                           if edAlbum.Text <> '' then cmd := cmd+SetAlbumTags(0) else cmd := cmd;
                           if edYear.Text <> '' then cmd := cmd+SetYearTags(0) else cmd := cmd;
                           if cbGenre.Text <> '' then cmd := cmd+SetGenreTags(0) else cmd := cmd;
                           if edPic.Text <> '' then cmd := cmd+SetPictureTags(0) else cmd := cmd; 
                      end;
                    cmd := cmd+'"';

                   { input path & filename }
                   cmd := cmd+' -add ';
                   cmd := cmd+'"'+FilesTagList.Selected.SubItems[0]+FilesTagList.Selected.SubItems[1]+'"'; // Path & FileName

                   { Temp dir }
                   if edTemp.Text <> '' then cmd := cmd+' -tmp '+edTemp.Text;

                   { Verbose Mode }
                   if chVerbose.Checked then
                     begin
                          cmd := cmd+' -v';
                          VerboseMode := True;
                     end
                   else cmd := cmd;

                   { overwitten input files }
                   cmd := cmd+' -new ';

                   { output path & filename }
                   cmd := cmd+'"'+FilesTagList.Selected.SubItems[0]+FilesTagList.Selected.SubItems[1]+'"';

                   { Add Message to Logfile }
                   AddMsg(Format(Msg13+' %s...', [FilesTagList.Selected.SubItems[1]]),0);
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg13+' %s...', [FilesTagList.Selected.SubItems[1]]));
                   DosCommand.CommandLine := cmd;
                   LogMsg.Add('['+FormatDateTime('hh:nn:ss',Now)+'] : '+Format(Msg12+' : %s', [cmd]));

                   { Execute command line & Priorities }
                   DosCommand.Execute;
                   PriorityCommand;
              end;
       end;  
end;

procedure TMainForm.btTagMoreClick(Sender: TObject);
begin
     Tagger := True;
     PropForm.Tab1.TabVisible := False; PropForm.Tab2.TabVisible := True; PropForm.TabMore.TabVisible := True;
     PropForm.TabPic.TabVisible := True; PropForm.chTagSupport.Visible := False;
     if edName.Text <> '' then PropForm.edName.Text := edName.Text;
     if edArtist.Text <> '' then PropForm.edArtist.Text := edArtist.Text;
     if edAlbum.Text <> '' then PropForm.edAlbum.Text := edAlbum.Text;
     if edYear.Text <> '' then propForm.edYear.Text := edYear.Text;
     if cbGenre.Text <> '' then PropForm.cbGenre.ItemIndex := cbGenre.ItemIndex;
     if edPic.Text <> '' then PropForm.ThumbView.SelectedFile := edPic.Text;
     if FilesTagList.Selected.SubItems[8] <> '' then PropForm.edWriter.Text := FilesTagList.Selected.SubItems[8];
     if FilesTagList.Selected.SubItems[9] <> '' then PropForm.edTrackN1.Text := FilesTagList.Selected.SubItems[9];
     if FilesTagList.Selected.SubItems[10] <> '' then PropForm.edTrackNum2.Text := FilesTagList.Selected.SubItems[10];
     if FilesTagList.Selected.SubItems[11] <> '' then PropForm.edDiskNum1.Text := FilesTagList.Selected.SubItems[11];
     if FilesTaglist.Selected.SubItems[12] <> '' then PropForm.edDiskNum2.Text := FilesTagList.Selected.SubItems[12];
     if FilesTagList.Selected.SubItems[13] <> '' then PropForm.edGroup.Text := FilesTagList.Selected.SubItems[13];
     if FilesTagList.Selected.SubItems[14] <> '' then PropForm.edTempo.Text := FilesTagList.Selected.SubItems[14];
     if FilesTagList.Selected.SubItems[15] <> '' then PropForm.edComposer.Text := FilesTagList.Selected.SubItems[15];
     if FilesTagList.Selected.SubItems[16] <> '' then PropForm.chCompile.Checked := True;
     if FilesTagList.Selected.SubItems[17] <> '' then PropForm.chGapless.Checked := True;
     if FilesTagList.Selected.SubItems[18] <> '' then PropForm.edEncoder.Text := FilesTagList.Selected.SubItems[18];
     if FilesTagList.Selected.SubItems[19] <> '' then PropForm.edTool.Text := FilesTagList.Selected.SubItems[19];
     if FilesTagList.Selected.SubItems[20] <> '' then PropForm.MemoComments.Text := FilesTagList.Selected.SubItems[20];
     PropForm.ShowModal;
end;

procedure TMainForm.WriteTags2;
begin
      if FilesTagList.Selected <> nil then
        begin
            if PropForm.edName.Text <> '' then
              begin
                   FilesTagList.Selected.SubItems[2] := PropForm.edName.Text;
                   edName.Text := PropForm.edName.Text;
              end;
            if PropForm.edArtist.Text <> '' then
              begin
                   FilesTagList.Selected.SubItems[4] := PropForm.edArtist.Text;
                   edArtist.Text := PropForm.edArtist.Text;
              end;
            if PropForm.edAlbum.Text <> '' then
              begin
                   FilesTagList.Selected.SubItems[5] := PropForm.edAlbum.Text;
                   edAlbum.Text := PropForm.edAlbum.Text;
              end;  
            if PropForm.edYear.Text <> '' then
              begin
                   FilesTagList.Selected.SubItems[6] := PropForm.edYear.Text;
                   EdYear.Text := PropForm.edYear.Text;
              end;
            if PropForm.cbGenre.Text <> '' then
              begin
                   FilesTagList.Selected.SubItems[7] := PropForm.cbGenre.Text;
                   cbGenre.ItemIndex := PropForm.cbGenre.ItemIndex;
              end;
            if PropForm.edWriter.Text <> '' then
                 FilesTagList.Selected.SubItems[8] := PropForm.edWriter.Text;
            if PropForm.edTrackN1.Text <> '' then
                 FilesTagList.Selected.SubItems[9] := PropForm.edTrackN1.Text;
            if PropForm.edTrackNum2.Text <> '' then
                 FilesTagList.Selected.SubItems[10] := PropForm.edTrackNum2.Text;
            if PropForm.edDiskNum1.Text <> '' then
                FilesTagList.Selected.SubItems[11] := PropForm.edDiskNum1.Text;
            if PropForm.edDiskNum2.Text <> '' then
                FilesTagList.Selected.SubItems[12] := PropForm.edDiskNum2.Text;
            if PropForm.edGroup.Text <> '' then
                FilesTagList.Selected.SubItems[13] := PropForm.edGroup.Text;
            if PropForm.edTempo.Text <> '' then
                FilesTagList.Selected.SubItems[14] := PropForm.edTempo.Text;
            if PropForm.edComposer.Text <> '' then
                FilesTagList.Selected.SubItems[15] := PropForm.edComposer.Text;
            if PropForm.chCompile.Checked then
              FilesTagList.Selected.SubItems[16] := 'compile';
            if PropForm.chGapless.Checked then
              FilesTagList.Selected.SubItems[17] := 'gapless';
            if PropForm.edEncoder.Text <> '' then
                FilesTagList.Selected.SubItems[18] := PropForm.edEncoder.Text;
            if PropForm.edTool.Text <> '' then
                FilesTagList.Selected.SubItems[19] := PropForm.edTool.Text;
            if PropForm.MemoComments.Text <> '' then
                FilesTagList.Selected.SubItems[20] := PropForm.MemoComments.Text;  
       end;
end;


procedure TMainForm.SettingsPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.WizardHelpButtonClick(Sender: TObject);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.MuxPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.ProcessPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.SplitPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.ConcatPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.ExtractPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.ConverterPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

procedure TMainForm.TagPageHelpButtonClick(Sender: TObject;
  var Stop: Boolean);
begin
     Tnt_ShellExecuteW(0, nil, YambWebSite, nil, nil, SW_NORMAL);
end;

end.
